import { MockAdapter } from '../mock-adapter';
const mock = MockAdapter.getInstance();

import Mock from 'mockjs'

// 获取全部数组
mock.onGet('./assets/json/data-dictionary.json').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    return [status, [
        {
        srfkey: 'Campaignactivity__ChannelTypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: 'Appointment',
                text: 'Appointment',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '7',
                label: 'Email',
                text: 'Email',
                "data":"",
                "codename":"Item_7",
                value: '7',
                
                disabled: false,
            },
            {
                id: '8',
                label: 'Email via Mail Merge',
                text: 'Email via Mail Merge',
                "data":"",
                "codename":"Item_8",
                value: '8',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Fax',
                text: 'Fax',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '6',
                label: 'Fax via Mail Merge',
                text: 'Fax via Mail Merge',
                "data":"",
                "codename":"Item_6",
                value: '6',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Letter',
                text: 'Letter',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Letter via Mail Merge',
                text: 'Letter via Mail Merge',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '9',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_9",
                value: '9',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Phone',
                text: 'Phone',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Status',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Active',
                text: 'Active',
                "data":"",
                "codename":"Item_1",
                value: 1,
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Inactive',
                text: 'Inactive',
                "data":"",
                "codename":"Item_2",
                value: 2,
                
                disabled: false,
            },
        ]
    },
    {
        "srfkey": "SysOperator",
        "emptytext": "未定义",
        "codelisttype":"dynamic",
        "appdataentity":"",
        "appdedataset":"",
        "items": []
    },
    {
        srfkey: 'Account__OwnershipCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '4',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Private',
                text: 'Private',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Public',
                text: 'Public',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Subsidiary',
                text: 'Subsidiary',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Contact__ShippingMethodCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Default Value',
                text: 'Default Value',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'YesNo',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: '是',
                text: '是',
                "data":"",
                "codename":"Item_1",
                value: 1,
                
                disabled: false,
            },
            {
                id: '0',
                label: '否',
                text: '否',
                "data":"",
                "codename":"Item_0",
                value: 0,
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Task__PriorityCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: 'High',
                text: 'High',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '0',
                label: 'Low',
                text: 'Low',
                "data":"",
                "codename":"Item_0",
                value: '0',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Normal',
                text: 'Normal',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Contact__FamilyStatusCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '3',
                label: 'Divorced',
                text: 'Divorced',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Married',
                text: 'Married',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Single',
                text: 'Single',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Widowed',
                text: 'Widowed',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__CustomerTypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Competitor',
                text: 'Competitor',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Consultant',
                text: 'Consultant',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Customer',
                text: 'Customer',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '6',
                label: 'Influencer',
                text: 'Influencer',
                "data":"",
                "codename":"Item_6",
                value: '6',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Investor',
                text: 'Investor',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '12',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_12",
                value: '12',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Partner',
                text: 'Partner',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '7',
                label: 'Press',
                text: 'Press',
                "data":"",
                "codename":"Item_7",
                value: '7',
                
                disabled: false,
            },
            {
                id: '8',
                label: 'Prospect',
                text: 'Prospect',
                "data":"",
                "codename":"Item_8",
                value: '8',
                
                disabled: false,
            },
            {
                id: '9',
                label: 'Reseller',
                text: 'Reseller',
                "data":"",
                "codename":"Item_9",
                value: '9',
                
                disabled: false,
            },
            {
                id: '10',
                label: 'Supplier',
                text: 'Supplier',
                "data":"",
                "codename":"Item_10",
                value: '10',
                
                disabled: false,
            },
            {
                id: '11',
                label: 'Vendor',
                text: 'Vendor',
                "data":"",
                "codename":"Item_11",
                value: '11',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__Address1_AddressTypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Bill To',
                text: 'Bill To',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Primary',
                text: 'Primary',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Ship To',
                text: 'Ship To',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Contact__PaymentTermsCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: '2% 10, Net 30',
                text: '2% 10, Net 30',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Net 30',
                text: 'Net 30',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Net 45',
                text: 'Net 45',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Net 60',
                text: 'Net 60',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__Address1_ShippingMethodCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Airborne',
                text: 'Airborne',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'DHL',
                text: 'DHL',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'FedEx',
                text: 'FedEx',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '6',
                label: 'Full Load',
                text: 'Full Load',
                "data":"",
                "codename":"Item_6",
                value: '6',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Postal Mail',
                text: 'Postal Mail',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'UPS',
                text: 'UPS',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '7',
                label: 'Will Call',
                text: 'Will Call',
                "data":"",
                "codename":"Item_7",
                value: '7',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Product__ProductTypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '4',
                label: 'Flat Fees',
                text: 'Flat Fees',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Miscellaneous Charges',
                text: 'Miscellaneous Charges',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Sales Inventory',
                text: 'Sales Inventory',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Services',
                text: 'Services',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'ActivityTypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: 'TASK',
                label: '任务',
                text: '任务',
                "data":{"N_ACTIVITYTYPECODE_EQ":"TASK"},
                "codename":"Task",
                value: 'TASK',
                
                disabled: false,
            },
            {
                id: 'EMAIL',
                label: '电子邮件',
                text: '电子邮件',
                "data":{"N_ACTIVITYTYPECODE_EQ":"EMAIL"},
                "codename":"Email",
                value: 'EMAIL',
                
                disabled: false,
            },
            {
                id: 'APPOINTMENT',
                label: '约会',
                text: '约会',
                "data":{"N_ACTIVITYTYPECODE_EQ":"APPOINTMENT"},
                "codename":"Appointment",
                value: 'APPOINTMENT',
                
                disabled: false,
            },
            {
                id: 'PHONECALL',
                label: '电话联络',
                text: '电话联络',
                "data":{"N_ACTIVITYTYPECODE_EQ":"PHONECALL"},
                "codename":"Phonecall",
                value: 'PHONECALL',
                
                disabled: false,
            },
            {
                id: 'LETTER',
                label: '信件',
                text: '信件',
                "data":{"N_ACTIVITYTYPECODE_EQ":"LETTER"},
                "codename":"Letter",
                value: 'LETTER',
                
                disabled: false,
            },
            {
                id: 'FAX',
                label: '传真',
                text: '传真',
                "data":"",
                "codename":"Fax",
                value: 'FAX',
                
                disabled: false,
            },
            {
                id: 'SERVICEAPPOINTMENT',
                label: '服务活动',
                text: '服务活动',
                "data":{"N_ACTIVITYTYPECODE_EQ":"SERVICEAPPOINTMENT"},
                "codename":"Serviceappointment",
                value: 'SERVICEAPPOINTMENT',
                
                disabled: false,
            },
            {
                id: 'CAMPAIGNRESPONSE',
                label: '市场活动响应',
                text: '市场活动响应',
                "data":{"N_ACTIVITYTYPECODE_EQ":"CAMPAIGNRESPONSE"},
                "codename":"Campaignresponse",
                value: 'CAMPAIGNRESPONSE',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Contact__GenderCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: 'Female',
                text: 'Female',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Male',
                text: 'Male',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'FQG_ActivityPointer',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: 'ALL',
                label: '全部活动',
                text: '全部活动',
                "data":{},
                "codename":"All",
                value: 'ALL',
                
                disabled: false,
            },
            {
                id: 'TASK',
                label: '任务',
                text: '任务',
                "data":{"n_activitytypecode_eq":"TASK"},
                "codename":"Task",
                value: 'TASK',
                
                disabled: false,
            },
            {
                id: 'EMAIL',
                label: '电子邮件',
                text: '电子邮件',
                "data":{"n_activitytypecode_eq":"EMAIL"},
                "codename":"Email",
                value: 'EMAIL',
                
                disabled: false,
            },
            {
                id: 'APPOINTMENT',
                label: '约会',
                text: '约会',
                "data":{"n_activitytypecode_eq":"APPOINTMENT"},
                "codename":"Appointment",
                value: 'APPOINTMENT',
                
                disabled: false,
            },
            {
                id: 'PHONECALL',
                label: '电话联络',
                text: '电话联络',
                "data":{"n_activitytypecode_eq":"PHONECALL"},
                "codename":"Phonecall",
                value: 'PHONECALL',
                
                disabled: false,
            },
            {
                id: 'OTHER',
                label: '其他',
                text: '其他',
                "data":"",
                "codename":"Other",
                value: 'OTHER',
                
                disabled: false,
            },
            {
                id: 'LETTER',
                label: '信件',
                text: '信件',
                "data":{"n_activitytypecode_eq":"LETTER"},
                "codename":"Letter",
                value: 'LETTER',
                "pvalue": "OTHER",
                disabled: false,
            },
            {
                id: 'FAX',
                label: '传真',
                text: '传真',
                "data":"",
                "codename":"Fax",
                value: 'FAX',
                "pvalue": "OTHER",
                disabled: false,
            },
            {
                id: 'SERVICEAPPOINTMENT',
                label: '服务活动',
                text: '服务活动',
                "data":{"n_activitytypecode_eq":"SERVICEAPPOINTMENT"},
                "codename":"Serviceappointment",
                value: 'SERVICEAPPOINTMENT',
                "pvalue": "OTHER",
                disabled: false,
            },
            {
                id: 'CAMPAIGNRESPONSE',
                label: '市场活动响应',
                text: '市场活动响应',
                "data":{"n_activitytypecode_eq":"CAMPAIGNRESPONSE"},
                "codename":"Campaignresponse",
                value: 'CAMPAIGNRESPONSE',
                "pvalue": "OTHER",
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Activitypointer__PriorityCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: 'High',
                text: 'High',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '0',
                label: 'Low',
                text: 'Low',
                "data":"",
                "codename":"Item_0",
                value: '0',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Normal',
                text: 'Normal',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Campaign__TypeCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Advertisement',
                text: 'Advertisement',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Co-branding',
                text: 'Co-branding',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Direct Marketing',
                text: 'Direct Marketing',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Event',
                text: 'Event',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__Address1_FreightTermsCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'FOB',
                text: 'FOB',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'No Charge',
                text: 'No Charge',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Lead__LeadSourceCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Advertisement',
                text: 'Advertisement',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Employee Referral',
                text: 'Employee Referral',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'External Referral',
                text: 'External Referral',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '10',
                label: 'Other',
                text: 'Other',
                "data":"",
                "codename":"Item_10",
                value: '10',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Partner',
                text: 'Partner',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Public Relations',
                text: 'Public Relations',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '6',
                label: 'Seminar',
                text: 'Seminar',
                "data":"",
                "codename":"Item_6",
                value: '6',
                
                disabled: false,
            },
            {
                id: '7',
                label: 'Trade Show',
                text: 'Trade Show',
                "data":"",
                "codename":"Item_7",
                value: '7',
                
                disabled: false,
            },
            {
                id: '8',
                label: 'Web',
                text: 'Web',
                "data":"",
                "codename":"Item_8",
                value: '8',
                
                disabled: false,
            },
            {
                id: '9',
                label: 'Word of Mouth',
                text: 'Word of Mouth',
                "data":"",
                "codename":"Item_9",
                value: '9',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__IndustryCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Accounting',
                text: 'Accounting',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Agriculture and Non-petrol Natural Resource Extraction',
                text: 'Agriculture and Non-petrol Natural Resource Extraction',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Broadcasting Printing and Publishing',
                text: 'Broadcasting Printing and Publishing',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Brokers',
                text: 'Brokers',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Building Supply Retail',
                text: 'Building Supply Retail',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '6',
                label: 'Business Services',
                text: 'Business Services',
                "data":"",
                "codename":"Item_6",
                value: '6',
                
                disabled: false,
            },
            {
                id: '7',
                label: 'Consulting',
                text: 'Consulting',
                "data":"",
                "codename":"Item_7",
                value: '7',
                
                disabled: false,
            },
            {
                id: '8',
                label: 'Consumer Services',
                text: 'Consumer Services',
                "data":"",
                "codename":"Item_8",
                value: '8',
                
                disabled: false,
            },
            {
                id: '9',
                label: 'Design, Direction and Creative Management',
                text: 'Design, Direction and Creative Management',
                "data":"",
                "codename":"Item_9",
                value: '9',
                
                disabled: false,
            },
            {
                id: '10',
                label: 'Distributors, Dispatchers and Processors',
                text: 'Distributors, Dispatchers and Processors',
                "data":"",
                "codename":"Item_10",
                value: '10',
                
                disabled: false,
            },
            {
                id: '11',
                label: 'Doctors Offices and Clinics',
                text: 'Doctors Offices and Clinics',
                "data":"",
                "codename":"Item_11",
                value: '11',
                
                disabled: false,
            },
            {
                id: '12',
                label: 'Durable Manufacturing',
                text: 'Durable Manufacturing',
                "data":"",
                "codename":"Item_12",
                value: '12',
                
                disabled: false,
            },
            {
                id: '13',
                label: 'Eating and Drinking Places',
                text: 'Eating and Drinking Places',
                "data":"",
                "codename":"Item_13",
                value: '13',
                
                disabled: false,
            },
            {
                id: '14',
                label: 'Entertainment Retail',
                text: 'Entertainment Retail',
                "data":"",
                "codename":"Item_14",
                value: '14',
                
                disabled: false,
            },
            {
                id: '15',
                label: 'Equipment Rental and Leasing',
                text: 'Equipment Rental and Leasing',
                "data":"",
                "codename":"Item_15",
                value: '15',
                
                disabled: false,
            },
            {
                id: '16',
                label: 'Financial',
                text: 'Financial',
                "data":"",
                "codename":"Item_16",
                value: '16',
                
                disabled: false,
            },
            {
                id: '17',
                label: 'Food and Tobacco Processing',
                text: 'Food and Tobacco Processing',
                "data":"",
                "codename":"Item_17",
                value: '17',
                
                disabled: false,
            },
            {
                id: '18',
                label: 'Inbound Capital Intensive Processing',
                text: 'Inbound Capital Intensive Processing',
                "data":"",
                "codename":"Item_18",
                value: '18',
                
                disabled: false,
            },
            {
                id: '19',
                label: 'Inbound Repair and Services',
                text: 'Inbound Repair and Services',
                "data":"",
                "codename":"Item_19",
                value: '19',
                
                disabled: false,
            },
            {
                id: '20',
                label: 'Insurance',
                text: 'Insurance',
                "data":"",
                "codename":"Item_20",
                value: '20',
                
                disabled: false,
            },
            {
                id: '21',
                label: 'Legal Services',
                text: 'Legal Services',
                "data":"",
                "codename":"Item_21",
                value: '21',
                
                disabled: false,
            },
            {
                id: '22',
                label: 'Non-Durable Merchandise Retail',
                text: 'Non-Durable Merchandise Retail',
                "data":"",
                "codename":"Item_22",
                value: '22',
                
                disabled: false,
            },
            {
                id: '23',
                label: 'Outbound Consumer Service',
                text: 'Outbound Consumer Service',
                "data":"",
                "codename":"Item_23",
                value: '23',
                
                disabled: false,
            },
            {
                id: '24',
                label: 'Petrochemical Extraction and Distribution',
                text: 'Petrochemical Extraction and Distribution',
                "data":"",
                "codename":"Item_24",
                value: '24',
                
                disabled: false,
            },
            {
                id: '25',
                label: 'Service Retail',
                text: 'Service Retail',
                "data":"",
                "codename":"Item_25",
                value: '25',
                
                disabled: false,
            },
            {
                id: '26',
                label: 'SIG Affiliations',
                text: 'SIG Affiliations',
                "data":"",
                "codename":"Item_26",
                value: '26',
                
                disabled: false,
            },
            {
                id: '27',
                label: 'Social Services',
                text: 'Social Services',
                "data":"",
                "codename":"Item_27",
                value: '27',
                
                disabled: false,
            },
            {
                id: '28',
                label: 'Special Outbound Trade Contractors',
                text: 'Special Outbound Trade Contractors',
                "data":"",
                "codename":"Item_28",
                value: '28',
                
                disabled: false,
            },
            {
                id: '29',
                label: 'Specialty Realty',
                text: 'Specialty Realty',
                "data":"",
                "codename":"Item_29",
                value: '29',
                
                disabled: false,
            },
            {
                id: '30',
                label: 'Transportation',
                text: 'Transportation',
                "data":"",
                "codename":"Item_30",
                value: '30',
                
                disabled: false,
            },
            {
                id: '31',
                label: 'Utility Creation and Distribution',
                text: 'Utility Creation and Distribution',
                "data":"",
                "codename":"Item_31",
                value: '31',
                
                disabled: false,
            },
            {
                id: '32',
                label: 'Vehicle Retail',
                text: 'Vehicle Retail',
                "data":"",
                "codename":"Item_32",
                value: '32',
                
                disabled: false,
            },
            {
                id: '33',
                label: 'Wholesale',
                text: 'Wholesale',
                "data":"",
                "codename":"Item_33",
                value: '33',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'State',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '0',
                label: 'Active',
                text: 'Active',
                "data":"",
                "codename":"Item_0",
                value: 0,
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Inactive',
                text: 'Inactive',
                "data":"",
                "codename":"Item_1",
                value: 1,
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Account__PreferredContactMethodCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: 'Any',
                text: 'Any',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
            {
                id: '2',
                label: 'Email',
                text: 'Email',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '4',
                label: 'Fax',
                text: 'Fax',
                "data":"",
                "codename":"Item_4",
                value: '4',
                
                disabled: false,
            },
            {
                id: '5',
                label: 'Mail',
                text: 'Mail',
                "data":"",
                "codename":"Item_5",
                value: '5',
                
                disabled: false,
            },
            {
                id: '3',
                label: 'Phone',
                text: 'Phone',
                "data":"",
                "codename":"Item_3",
                value: '3',
                
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'Phonecall__PriorityCode',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '2',
                label: 'High',
                text: 'High',
                "data":"",
                "codename":"Item_2",
                value: '2',
                
                disabled: false,
            },
            {
                id: '0',
                label: 'Low',
                text: 'Low',
                "data":"",
                "codename":"Item_0",
                value: '0',
                
                disabled: false,
            },
            {
                id: '1',
                label: 'Normal',
                text: 'Normal',
                "data":"",
                "codename":"Item_1",
                value: '1',
                
                disabled: false,
            },
        ]
    }
    ]];
});

