/**
 * Market 部件模型
 *
 * @export
 * @class MarketModel
 */
export default class MarketModel {

  /**
  * 获取数据项集合
  *
  * @returns {any[]}
  * @memberof MarketModel
  */
  public getDataItems(): any[] {
    return [
      {
        name: 'srfwfmemo',
        prop: 'srfwfmemo',
        dataType: 'TEXT',
      },
      // 前端新增修改标识，新增为"0",修改为"1"或未设值
      {
        name: 'srffrontuf',
        prop: 'srffrontuf',
        dataType: 'TEXT',
      },
      {
        name: 'srfupdatedate',
        prop: 'updatedate',
        dataType: 'DATETIME',
      },
      {
        name: 'srforikey',
      },
      {
        name: 'srfkey',
        prop: 'contactid',
        dataType: 'GUID',
      },
      {
        name: 'srfmajortext',
        prop: 'fullname',
        dataType: 'TEXT',
      },
      {
        name: 'srftempmode',
      },
      {
        name: 'srfuf',
      },
      {
        name: 'srfdeid',
      },
      {
        name: 'srfsourcekey',
      },
      {
        name: 'originatingleadname',
        prop: 'originatingleadname',
        dataType: 'PICKUPTEXT',
      },
      {
        name: 'lastusedincampaign',
        prop: 'lastusedincampaign',
        dataType: 'DATETIME',
      },
      {
        name: 'donotsendmm',
        prop: 'donotsendmm',
        dataType: 'YESNO',
      },
      {
        name: 'shippingmethodcode',
        prop: 'shippingmethodcode',
        dataType: 'SSCODELIST',
      },
      {
        name: 'originatingleadid',
        prop: 'originatingleadid',
        dataType: 'PICKUP',
      },
      {
        name: 'contactid',
        prop: 'contactid',
        dataType: 'GUID',
      },
      {
        name: 'contact',
        prop: 'contactid',
        dataType: 'FONTKEY',
      },
    ]
  }

}