package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[组织]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "ORGANIZATION",resultMap = "OrganizationResultMap")
public class Organization extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * EnableLivePersonaCardUCI
     */
    @DEField(defaultValue = "0")
    @TableField(value = "enablelivepersonacarduci")
    @JSONField(name = "enablelivepersonacarduci")
    @JsonProperty("enablelivepersonacarduci")
    private Integer enablelivepersonacarduci;
    /**
     * 为此组织启用自动捕获
     */
    @DEField(defaultValue = "0")
    @TableField(value = "autodatacaptureenabled")
    @JSONField(name = "autodatacaptureenabled")
    @JsonProperty("autodatacaptureenabled")
    private Integer autodatacaptureenabled;
    /**
     * 允许 Outlook 客户端消息栏广告
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowclientmessagebarad")
    @JSONField(name = "allowclientmessagebarad")
    @JsonProperty("allowclientmessagebarad")
    private Integer allowclientmessagebarad;
    /**
     * Yammer 组 ID
     */
    @TableField(value = "yammergroupid")
    @JSONField(name = "yammergroupid")
    @JsonProperty("yammergroupid")
    private Integer yammergroupid;
    /**
     * 目标的自动汇总频率
     */
    @TableField(value = "goalrollupfrequency")
    @JSONField(name = "goalrollupfrequency")
    @JsonProperty("goalrollupfrequency")
    private Integer goalrollupfrequency;
    /**
     * 年起始周代码
     */
    @TableField(value = "yearstartweekcode")
    @JSONField(name = "yearstartweekcode")
    @JsonProperty("yearstartweekcode")
    private Integer yearstartweekcode;
    /**
     * 启用 OOB 价格计算
     */
    @DEField(defaultValue = "1")
    @TableField(value = "oobpricecalculationenabled")
    @JSONField(name = "oobpricecalculationenabled")
    @JsonProperty("oobpricecalculationenabled")
    private Integer oobpricecalculationenabled;
    /**
     * 为此组织启用应用程序设计器体验
     */
    @DEField(defaultValue = "0")
    @TableField(value = "appdesignerexperienceenabled")
    @JSONField(name = "appdesignerexperienceenabled")
    @JsonProperty("appdesignerexperienceenabled")
    private Integer appdesignerexperienceenabled;
    /**
     * 旧窗体呈现
     */
    @DEField(defaultValue = "0")
    @TableField(value = "uselegacyrendering")
    @JSONField(name = "uselegacyrendering")
    @JsonProperty("uselegacyrendering")
    private Integer uselegacyrendering;
    /**
     * Web 资源哈希
     */
    @TableField(value = "webresourcehash")
    @JSONField(name = "webresourcehash")
    @JsonProperty("webresourcehash")
    private String webresourcehash;
    /**
     * 用户 Skype 协议
     */
    @DEField(defaultValue = "1")
    @TableField(value = "useskypeprotocol")
    @JSONField(name = "useskypeprotocol")
    @JsonProperty("useskypeprotocol")
    private Integer useskypeprotocol;
    /**
     * 为此组织启用注释分析
     */
    @DEField(defaultValue = "0")
    @TableField(value = "notesanalysisenabled")
    @JSONField(name = "notesanalysisenabled")
    @JsonProperty("notesanalysisenabled")
    private Integer notesanalysisenabled;
    /**
     * 基础 ISO 货币代码
     */
    @TableField(value = "baseisocurrencycode")
    @JSONField(name = "baseisocurrencycode")
    @JsonProperty("baseisocurrencycode")
    private String baseisocurrencycode;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 区域设置
     */
    @TableField(value = "localeid")
    @JSONField(name = "localeid")
    @JsonProperty("localeid")
    private Integer localeid;
    /**
     * ExternalPartyEnabled 实体设置。仅供内部使用。
     */
    @TableField(value = "externalpartyentitysettings")
    @JSONField(name = "externalpartyentitysettings")
    @JsonProperty("externalpartyentitysettings")
    private String externalpartyentitysettings;
    /**
     * 启用与 Microsoft Flow 的集成
     */
    @DEField(defaultValue = "0")
    @TableField(value = "enablemicrosoftflowintegration")
    @JSONField(name = "enablemicrosoftflowintegration")
    @JsonProperty("enablemicrosoftflowintegration")
    private Integer enablemicrosoftflowintegration;
    /**
     * 是否禁用组织
     */
    @DEField(defaultValue = "0")
    @TableField(value = "disabled")
    @JSONField(name = "disabled")
    @JsonProperty("disabled")
    private Integer disabled;
    /**
     * 最低脱机同步频率
     */
    @TableField(value = "minofflinesyncinterval")
    @JSONField(name = "minofflinesyncinterval")
    @JsonProperty("minofflinesyncinterval")
    private Integer minofflinesyncinterval;
    /**
     * 允许实体级审核
     */
    @DEField(defaultValue = "1")
    @TableField(value = "allowentityonlyaudit")
    @JSONField(name = "allowentityonlyaudit")
    @JsonProperty("allowentityonlyaudit")
    private Integer allowentityonlyaudit;
    /**
     * 允许通讯簿同步
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowaddressbooksyncs")
    @JSONField(name = "allowaddressbooksyncs")
    @JsonProperty("allowaddressbooksyncs")
    private Integer allowaddressbooksyncs;
    /**
     * 会计年度后缀
     */
    @TableField(value = "fiscalyearformatsuffix")
    @JSONField(name = "fiscalyearformatsuffix")
    @JsonProperty("fiscalyearformatsuffix")
    private String fiscalyearformatsuffix;
    /**
     * 为此组织启用任务流流程
     */
    @DEField(defaultValue = "0")
    @TableField(value = "taskbasedflowenabled")
    @JSONField(name = "taskbasedflowenabled")
    @JsonProperty("taskbasedflowenabled")
    private Integer taskbasedflowenabled;
    /**
     * 生产/预览组织的 Mobile Offline 服务所需的最小用户许可证数
     */
    @TableField(value = "mobileofflineminlicenseprod")
    @JSONField(name = "mobileofflineminlicenseprod")
    @JsonProperty("mobileofflineminlicenseprod")
    private Integer mobileofflineminlicenseprod;
    /**
     * 下一个跟踪号
     */
    @TableField(value = "nexttrackingnumber")
    @JSONField(name = "nexttrackingnumber")
    @JsonProperty("nexttrackingnumber")
    private Integer nexttrackingnumber;
    /**
     * 报告组
     */
    @TableField(value = "reportinggroupid")
    @JSONField(name = "reportinggroupid")
    @JsonProperty("reportinggroupid")
    private String reportinggroupid;
    /**
     * 下一个实体类型代码
     */
    @TableField(value = "nextcustomobjecttypecode")
    @JSONField(name = "nextcustomobjecttypecode")
    @JsonProperty("nextcustomobjecttypecode")
    private Integer nextcustomobjecttypecode;
    /**
     * 当前类别编号
     */
    @TableField(value = "currentcategorynumber")
    @JSONField(name = "currentcategorynumber")
    @JsonProperty("currentcategorynumber")
    private Integer currentcategorynumber;
    /**
     * 支持用户
     */
    @TableField(value = "supportuserid")
    @JSONField(name = "supportuserid")
    @JsonProperty("supportuserid")
    private String supportuserid;
    /**
     * AllowLegacyDialogsEmbedding
     */
    @DEField(defaultValue = "1")
    @TableField(value = "allowlegacydialogsembedding")
    @JSONField(name = "allowlegacydialogsembedding")
    @JsonProperty("allowlegacydialogsembedding")
    private Integer allowlegacydialogsembedding;
    /**
     * 外部基本 URL
     */
    @TableField(value = "externalbaseurl")
    @JSONField(name = "externalbaseurl")
    @JsonProperty("externalbaseurl")
    private String externalbaseurl;
    /**
     * 操作支持功能已启用
     */
    @DEField(defaultValue = "0")
    @TableField(value = "actionsupportfeatureenabled")
    @JSONField(name = "actionsupportfeatureenabled")
    @JsonProperty("actionsupportfeatureenabled")
    private Integer actionsupportfeatureenabled;
    /**
     * 生成错误警报
     */
    @DEField(defaultValue = "1")
    @TableField(value = "generatealertsforerrors")
    @JSONField(name = "generatealertsforerrors")
    @JsonProperty("generatealertsforerrors")
    private Integer generatealertsforerrors;
    /**
     * 呈现电子邮件的安全框架
     */
    @DEField(defaultValue = "0")
    @TableField(value = "rendersecureiframeforemail")
    @JSONField(name = "rendersecureiframeforemail")
    @JsonProperty("rendersecureiframeforemail")
    private Integer rendersecureiframeforemail;
    /**
     * 令牌到期期限
     */
    @TableField(value = "tokenexpiry")
    @JSONField(name = "tokenexpiry")
    @JsonProperty("tokenexpiry")
    private Integer tokenexpiry;
    /**
     * 定价小数精度
     */
    @TableField(value = "pricingdecimalprecision")
    @JSONField(name = "pricingdecimalprecision")
    @JsonProperty("pricingdecimalprecision")
    private Integer pricingdecimalprecision;
    /**
     * ManualSalesForecastingEnabled
     */
    @DEField(defaultValue = "0")
    @TableField(value = "manualsalesforecastingenabled")
    @JSONField(name = "manualsalesforecastingenabled")
    @JsonProperty("manualsalesforecastingenabled")
    private Integer manualsalesforecastingenabled;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * 启用学习路径创作
     */
    @DEField(defaultValue = "0")
    @TableField(value = "enablelpauthoring")
    @JSONField(name = "enablelpauthoring")
    @JsonProperty("enablelpauthoring")
    private Integer enablelpauthoring;
    /**
     * 用户组
     */
    @TableField(value = "usergroupid")
    @JSONField(name = "usergroupid")
    @JsonProperty("usergroupid")
    private String usergroupid;
    /**
     * 为此组织启用 Power BI 功能
     */
    @DEField(defaultValue = "0")
    @TableField(value = "powerbifeatureenabled")
    @JSONField(name = "powerbifeatureenabled")
    @JsonProperty("powerbifeatureenabled")
    private Integer powerbifeatureenabled;
    /**
     * 邮箱永久性问题的下限值。
     */
    @TableField(value = "mailboxpermanentissueminrange")
    @JSONField(name = "mailboxpermanentissueminrange")
    @JsonProperty("mailboxpermanentissueminrange")
    private Integer mailboxpermanentissueminrange;
    /**
     * 社交透析使用条款
     */
    @DEField(defaultValue = "0")
    @TableField(value = "socialinsightstermsaccepted")
    @JSONField(name = "socialinsightstermsaccepted")
    @JsonProperty("socialinsightstermsaccepted")
    private Integer socialinsightstermsaccepted;
    /**
     * 是否启用读取审核
     */
    @DEField(defaultValue = "0")
    @TableField(value = "readauditenabled")
    @JSONField(name = "readauditenabled")
    @JsonProperty("readauditenabled")
    private Integer readauditenabled;
    /**
     * 最多记录数筛选选择
     */
    @TableField(value = "maxrecordsforlookupfilters")
    @JSONField(name = "maxrecordsforlookupfilters")
    @JsonProperty("maxrecordsforlookupfilters")
    private Integer maxrecordsforlookupfilters;
    /**
     * 基于文件夹的跟踪映射最大数量
     */
    @TableField(value = "maxfolderbasedtrackingmappings")
    @JSONField(name = "maxfolderbasedtrackingmappings")
    @JsonProperty("maxfolderbasedtrackingmappings")
    private Integer maxfolderbasedtrackingmappings;
    /**
     * 基础货币符号
     */
    @TableField(value = "basecurrencysymbol")
    @JSONField(name = "basecurrencysymbol")
    @JsonProperty("basecurrencysymbol")
    private String basecurrencysymbol;
    /**
     * 为此组织启用 MobileOffline
     */
    @DEField(defaultValue = "0")
    @TableField(value = "mobileofflineenabled")
    @JSONField(name = "mobileofflineenabled")
    @JsonProperty("mobileofflineenabled")
    private Integer mobileofflineenabled;
    /**
     * 默认电子邮件设置
     */
    @TableField(value = "defaultemailsettings")
    @JSONField(name = "defaultemailsettings")
    @JsonProperty("defaultemailsettings")
    private String defaultemailsettings;
    /**
     * 是否需要审批用户电子邮件
     */
    @DEField(defaultValue = "0")
    @TableField(value = "requireapprovalforuseremail")
    @JSONField(name = "requireapprovalforuseremail")
    @JsonProperty("requireapprovalforuseremail")
    private Integer requireapprovalforuseremail;
    /**
     * 试用组织的 Mobile Offline 服务所需的最小用户许可证数
     */
    @TableField(value = "mobileofflineminlicensetrial")
    @JSONField(name = "mobileofflineminlicensetrial")
    @JsonProperty("mobileofflineminlicensetrial")
    private Integer mobileofflineminlicensetrial;
    /**
     * 隐私声明 URL
     */
    @TableField(value = "privacystatementurl")
    @JSONField(name = "privacystatementurl")
    @JsonProperty("privacystatementurl")
    private String privacystatementurl;
    /**
     * 哈希最少地址数
     */
    @TableField(value = "hashminaddresscount")
    @JSONField(name = "hashminaddresscount")
    @JsonProperty("hashminaddresscount")
    private Integer hashminaddresscount;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 日历类型
     */
    @TableField(value = "calendartype")
    @JSONField(name = "calendartype")
    @JsonProperty("calendartype")
    private Integer calendartype;
    /**
     * 分派时与先前负责人共享
     */
    @DEField(defaultValue = "0")
    @TableField(value = "sharetopreviousowneronassign")
    @JSONField(name = "sharetopreviousowneronassign")
    @JsonProperty("sharetopreviousowneronassign")
    private Integer sharetopreviousowneronassign;
    /**
     * 当前批量操作号
     */
    @TableField(value = "currentbulkoperationnumber")
    @JSONField(name = "currentbulkoperationnumber")
    @JsonProperty("currentbulkoperationnumber")
    private Integer currentbulkoperationnumber;
    /**
     * Relationship Insights 设置的错误状态。
     */
    @TableField(value = "rierrorstatus")
    @JSONField(name = "rierrorstatus")
    @JsonProperty("rierrorstatus")
    private Integer rierrorstatus;
    /**
     * 电子邮件连接通道
     */
    @TableField(value = "emailconnectionchannel")
    @JSONField(name = "emailconnectionchannel")
    @JsonProperty("emailconnectionchannel")
    private String emailconnectionchannel;
    /**
     * 允许自动创建响应
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowautoresponsecreation")
    @JSONField(name = "allowautoresponsecreation")
    @JsonProperty("allowautoresponsecreation")
    private Integer allowautoresponsecreation;
    /**
     * 是否启用已分派任务同步
     */
    @DEField(defaultValue = "0")
    @TableField(value = "assignedtaskssyncenabled")
    @JSONField(name = "assignedtaskssyncenabled")
    @JsonProperty("assignedtaskssyncenabled")
    private Integer assignedtaskssyncenabled;
    /**
     * 唯一字符串长度
     */
    @TableField(value = "uniquespecifierlength")
    @JSONField(name = "uniquespecifierlength")
    @JsonProperty("uniquespecifierlength")
    private Integer uniquespecifierlength;
    /**
     * 仅供内部使用。
     */
    @TableField(value = "postmessagewhitelistdomains")
    @JSONField(name = "postmessagewhitelistdomains")
    @JsonProperty("postmessagewhitelistdomains")
    private String postmessagewhitelistdomains;
    /**
     * 已启用自动保存
     */
    @DEField(defaultValue = "1")
    @TableField(value = "autosaveenabled")
    @JSONField(name = "autosaveenabled")
    @JsonProperty("autosaveenabled")
    private Integer autosaveenabled;
    /**
     * 货币符号
     */
    @TableField(value = "currencysymbol")
    @JSONField(name = "currencysymbol")
    @JsonProperty("currencysymbol")
    private String currencysymbol;
    /**
     * 是否启用销售订单集成
     */
    @DEField(defaultValue = "0")
    @TableField(value = "sopintegrationenabled")
    @JSONField(name = "sopintegrationenabled")
    @JsonProperty("sopintegrationenabled")
    private Integer sopintegrationenabled;
    /**
     * 会计期间是否为每月
     */
    @DEField(defaultValue = "0")
    @TableField(value = "fiscalperiodmonthbased")
    @JSONField(name = "fiscalperiodmonthbased")
    @JsonProperty("fiscalperiodmonthbased")
    private Integer fiscalperiodmonthbased;
    /**
     * 是否启用应用程序模式
     */
    @DEField(defaultValue = "0")
    @TableField(value = "appmode")
    @JSONField(name = "appmode")
    @JsonProperty("appmode")
    private Integer appmode;
    /**
     * 全名显示顺序
     */
    @TableField(value = "fullnameconventioncode")
    @JSONField(name = "fullnameconventioncode")
    @JsonProperty("fullnameconventioncode")
    private String fullnameconventioncode;
    /**
     * 当前报价单号
     */
    @TableField(value = "currentquotenumber")
    @JSONField(name = "currentquotenumber")
    @JsonProperty("currentquotenumber")
    private Integer currentquotenumber;
    /**
     * 通过电子邮件发送轮询频率
     */
    @TableField(value = "emailsendpollingperiod")
    @JSONField(name = "emailsendpollingperiod")
    @JsonProperty("emailsendpollingperiod")
    private Integer emailsendpollingperiod;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * MSTeamsUserSyncEnabled
     */
    @DEField(defaultValue = "0")
    @TableField(value = "msteamsusersyncenabled")
    @JSONField(name = "msteamsusersyncenabled")
    @JsonProperty("msteamsusersyncenabled")
    private Integer msteamsusersyncenabled;
    /**
     * 约会最长持续时间
     */
    @TableField(value = "maxappointmentdurationdays")
    @JSONField(name = "maxappointmentdurationdays")
    @JsonProperty("maxappointmentdurationdays")
    private Integer maxappointmentdurationdays;
    /**
     * 折扣计算方法
     */
    @TableField(value = "discountcalculationmethod")
    @JSONField(name = "discountcalculationmethod")
    @JsonProperty("discountcalculationmethod")
    private String discountcalculationmethod;
    /**
     * 生成信息性警报
     */
    @DEField(defaultValue = "1")
    @TableField(value = "generatealertsforinformation")
    @JSONField(name = "generatealertsforinformation")
    @JsonProperty("generatealertsforinformation")
    private Integer generatealertsforinformation;
    /**
     * 是否启用代理访问权限
     */
    @DEField(defaultValue = "0")
    @TableField(value = "delegateaccessenabled")
    @JSONField(name = "delegateaccessenabled")
    @JsonProperty("delegateaccessenabled")
    private Integer delegateaccessenabled;
    /**
     * 为此组织启用文本分析
     */
    @DEField(defaultValue = "0")
    @TableField(value = "textanalyticsenabled")
    @JSONField(name = "textanalyticsenabled")
    @JsonProperty("textanalyticsenabled")
    private Integer textanalyticsenabled;
    /**
     * 哈希增量主题数
     */
    @TableField(value = "hashdeltasubjectcount")
    @JSONField(name = "hashdeltasubjectcount")
    @JsonProperty("hashdeltasubjectcount")
    private Integer hashdeltasubjectcount;
    /**
     * 预订到期前的天数
     */
    @TableField(value = "expiresubscriptionsindays")
    @JSONField(name = "expiresubscriptionsindays")
    @JsonProperty("expiresubscriptionsindays")
    private Integer expiresubscriptionsindays;
    /**
     * 知识管理设置
     */
    @TableField(value = "kmsettings")
    @JSONField(name = "kmsettings")
    @JsonProperty("kmsettings")
    private String kmsettings;
    /**
     * 过去的扩展窗口
     */
    @TableField(value = "pastexpansionwindow")
    @JSONField(name = "pastexpansionwindow")
    @JsonProperty("pastexpansionwindow")
    private Integer pastexpansionwindow;
    /**
     * Yammer OAuth 访问令牌已过期
     */
    @DEField(defaultValue = "0")
    @TableField(value = "yammeroauthaccesstokenexpired")
    @JSONField(name = "yammeroauthaccesstokenexpired")
    @JsonProperty("yammeroauthaccesstokenexpired")
    private Integer yammeroauthaccesstokenexpired;
    /**
     * 用于打开 Delve 的 URL
     */
    @TableField(value = "officegraphdelveurl")
    @JSONField(name = "officegraphdelveurl")
    @JsonProperty("officegraphdelveurl")
    private String officegraphdelveurl;
    /**
     * 高对比度主题数据
     */
    @TableField(value = "highcontrastthemedata")
    @JSONField(name = "highcontrastthemedata")
    @JsonProperty("highcontrastthemedata")
    private String highcontrastthemedata;
    /**
     * 电子邮件服务器配置文件
     */
    @TableField(value = "defaultemailserverprofileid")
    @JSONField(name = "defaultemailserverprofileid")
    @JsonProperty("defaultemailserverprofileid")
    private String defaultemailserverprofileid;
    /**
     * 时间格式代码
     */
    @TableField(value = "timeformatcode")
    @JSONField(name = "timeformatcode")
    @JsonProperty("timeformatcode")
    private String timeformatcode;
    /**
     * 小数点
     */
    @TableField(value = "decimalsymbol")
    @JSONField(name = "decimalsymbol")
    @JsonProperty("decimalsymbol")
    private String decimalsymbol;
    /**
     * 导出到 Excel 的最多记录数
     */
    @TableField(value = "maxrecordsforexporttoexcel")
    @JSONField(name = "maxrecordsforexporttoexcel")
    @JsonProperty("maxrecordsforexporttoexcel")
    private Integer maxrecordsforexporttoexcel;
    /**
     * 默认情况下为其启用详细信息日志记录的同步周期的最大数目
     */
    @TableField(value = "maxverboseloggingsynccycles")
    @JSONField(name = "maxverboseloggingsynccycles")
    @JsonProperty("maxverboseloggingsynccycles")
    private Integer maxverboseloggingsynccycles;
    /**
     * 自定义名称前缀
     */
    @TableField(value = "schemanameprefix")
    @JSONField(name = "schemanameprefix")
    @JsonProperty("schemanameprefix")
    private String schemanameprefix;
    /**
     * 是否需要审批队列电子邮件
     */
    @DEField(defaultValue = "0")
    @TableField(value = "requireapprovalforqueueemail")
    @JSONField(name = "requireapprovalforqueueemail")
    @JsonProperty("requireapprovalforqueueemail")
    private Integer requireapprovalforqueueemail;
    /**
     * ACI 租户 URL。
     */
    @TableField(value = "aciwebendpointurl")
    @JSONField(name = "aciwebendpointurl")
    @JsonProperty("aciwebendpointurl")
    private String aciwebendpointurl;
    /**
     * 当前市场活动号
     */
    @TableField(value = "currentcampaignnumber")
    @JSONField(name = "currentcampaignnumber")
    @JsonProperty("currentcampaignnumber")
    private Integer currentcampaignnumber;
    /**
     * 当前文章编号
     */
    @TableField(value = "currentkbnumber")
    @JSONField(name = "currentkbnumber")
    @JsonProperty("currentkbnumber")
    private Integer currentkbnumber;
    /**
     * 已启用不活动超时
     */
    @DEField(defaultValue = "0")
    @TableField(value = "inactivitytimeoutenabled")
    @JSONField(name = "inactivitytimeoutenabled")
    @JsonProperty("inactivitytimeoutenabled")
    private Integer inactivitytimeoutenabled;
    /**
     * Yammer 网络固定链接
     */
    @TableField(value = "yammernetworkpermalink")
    @JSONField(name = "yammernetworkpermalink")
    @JsonProperty("yammernetworkpermalink")
    private String yammernetworkpermalink;
    /**
     * 会计期间类型
     */
    @TableField(value = "fiscalperiodtype")
    @JSONField(name = "fiscalperiodtype")
    @JsonProperty("fiscalperiodtype")
    private Integer fiscalperiodtype;
    /**
     * 当前订单号
     */
    @TableField(value = "currentordernumber")
    @JSONField(name = "currentordernumber")
    @JsonProperty("currentordernumber")
    private Integer currentordernumber;
    /**
     * 当前案例号
     */
    @TableField(value = "currentcasenumber")
    @JSONField(name = "currentcasenumber")
    @JsonProperty("currentcasenumber")
    private Integer currentcasenumber;
    /**
     * ExternalPartyEnabled 实体相关键
     */
    @TableField(value = "externalpartycorrelationkeys")
    @JSONField(name = "externalpartycorrelationkeys")
    @JsonProperty("externalpartycorrelationkeys")
    private String externalpartycorrelationkeys;
    /**
     * CRMForOutlookDownloadURL
     */
    @TableField(value = "signupoutlookdownloadfwlink")
    @JSONField(name = "signupoutlookdownloadfwlink")
    @JsonProperty("signupoutlookdownloadfwlink")
    private String signupoutlookdownloadfwlink;
    /**
     * 会计期间格式
     */
    @TableField(value = "fiscalperiodformat")
    @JSONField(name = "fiscalperiodformat")
    @JsonProperty("fiscalperiodformat")
    private String fiscalperiodformat;
    /**
     * 允许执行市场营销电子邮件
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowmarketingemailexecution")
    @JSONField(name = "allowmarketingemailexecution")
    @JsonProperty("allowmarketingemailexecution")
    private Integer allowmarketingemailexecution;
    /**
     * 权限报告组名称
     */
    @TableField(value = "privreportinggroupname")
    @JSONField(name = "privreportinggroupname")
    @JsonProperty("privreportinggroupname")
    private String privreportinggroupname;
    /**
     * 自动创建文件夹
     */
    @DEField(defaultValue = "0")
    @TableField(value = "folderautocreatedonsp")
    @JSONField(name = "folderautocreatedonsp")
    @JsonProperty("folderautocreatedonsp")
    private Integer folderautocreatedonsp;
    /**
     * 用户访问审核已启用
     */
    @DEField(defaultValue = "0")
    @TableField(value = "useraccessauditenabled")
    @JSONField(name = "useraccessauditenabled")
    @JsonProperty("useraccessauditenabled")
    private Integer useraccessauditenabled;
    /**
     * SQL 访问组
     */
    @TableField(value = "sqlaccessgroupid")
    @JSONField(name = "sqlaccessgroupid")
    @JsonProperty("sqlaccessgroupid")
    private String sqlaccessgroupid;
    /**
     * 跟踪令牌基数
     */
    @TableField(value = "trackingtokenidbase")
    @JSONField(name = "trackingtokenidbase")
    @JsonProperty("trackingtokenidbase")
    private Integer trackingtokenidbase;
    /**
     * 合同前缀
     */
    @TableField(value = "contractprefix")
    @JSONField(name = "contractprefix")
    @JsonProperty("contractprefix")
    private String contractprefix;
    /**
     * BPF 中允许的操作步骤的最大数量
     */
    @TableField(value = "maxactionstepsinbpf")
    @JSONField(name = "maxactionstepsinbpf")
    @JsonProperty("maxactionstepsinbpf")
    private Integer maxactionstepsinbpf;
    /**
     * 为此组织启用关系分析
     */
    @DEField(defaultValue = "0")
    @TableField(value = "activityanalysisenabled")
    @JSONField(name = "activityanalysisenabled")
    @JsonProperty("activityanalysisenabled")
    private Integer activityanalysisenabled;
    /**
     * 类别前缀
     */
    @TableField(value = "categoryprefix")
    @JSONField(name = "categoryprefix")
    @JsonProperty("categoryprefix")
    private String categoryprefix;
    /**
     * SLA 暂停状态
     */
    @TableField(value = "slapausestates")
    @JSONField(name = "slapausestates")
    @JsonProperty("slapausestates")
    private String slapausestates;
    /**
     * 组织数据库组织设置
     */
    @TableField(value = "orgdborgsettings")
    @JSONField(name = "orgdborgsettings")
    @JsonProperty("orgdborgsettings")
    private String orgdborgsettings;
    /**
     * 启用外部搜索数据同步
     */
    @DEField(defaultValue = "0")
    @TableField(value = "externalsearchindexenabled")
    @JSONField(name = "externalsearchindexenabled")
    @JsonProperty("externalsearchindexenabled")
    private Integer externalsearchindexenabled;
    /**
     * 组织状态
     */
    @TableField(value = "organizationstate")
    @JSONField(name = "organizationstate")
    @JsonProperty("organizationstate")
    private String organizationstate;
    /**
     * 阻止附件
     */
    @TableField(value = "blockedattachments")
    @JSONField(name = "blockedattachments")
    @JsonProperty("blockedattachments")
    private String blockedattachments;
    /**
     * 已解析表前缀
     */
    @TableField(value = "parsedtableprefix")
    @JSONField(name = "parsedtableprefix")
    @JsonProperty("parsedtableprefix")
    private String parsedtableprefix;
    /**
     * 语言
     */
    @TableField(value = "languagecode")
    @JSONField(name = "languagecode")
    @JsonProperty("languagecode")
    private Integer languagecode;
    /**
     * 时间分隔符
     */
    @TableField(value = "timeseparator")
    @JSONField(name = "timeseparator")
    @JsonProperty("timeseparator")
    private String timeseparator;
    /**
     * 最低同步频率
     */
    @TableField(value = "minoutlooksyncinterval")
    @JSONField(name = "minoutlooksyncinterval")
    @JsonProperty("minoutlooksyncinterval")
    private Integer minoutlooksyncinterval;
    /**
     * 是否启用 SQM
     */
    @DEField(defaultValue = "0")
    @TableField(value = "sqmenabled")
    @JSONField(name = "sqmenabled")
    @JsonProperty("sqmenabled")
    private Integer sqmenabled;
    /**
     * 选择要与 Microsoft Flow 集成的环境
     */
    @TableField(value = "microsoftflowenvironment")
    @JSONField(name = "microsoftflowenvironment")
    @JsonProperty("microsoftflowenvironment")
    private String microsoftflowenvironment;
    /**
     * 选择 SharePoint 部署类型
     */
    @TableField(value = "sharepointdeploymenttype")
    @JSONField(name = "sharepointdeploymenttype")
    @JsonProperty("sharepointdeploymenttype")
    private String sharepointdeploymenttype;
    /**
     * 在更新服务案例时自动应用默认权利
     */
    @DEField(defaultValue = "0")
    @TableField(value = "autoapplydefaultoncaseupdate")
    @JSONField(name = "autoapplydefaultoncaseupdate")
    @JsonProperty("autoapplydefaultoncaseupdate")
    private Integer autoapplydefaultoncaseupdate;
    /**
     * 启用显示状态
     */
    @DEField(defaultValue = "1")
    @TableField(value = "presenceenabled")
    @JSONField(name = "presenceenabled")
    @JsonProperty("presenceenabled")
    private Integer presenceenabled;
    /**
     * 为此组织启用 OrgInsights
     */
    @DEField(defaultValue = "0")
    @TableField(value = "orginsightsenabled")
    @JSONField(name = "orginsightsenabled")
    @JsonProperty("orginsightsenabled")
    private Integer orginsightsenabled;
    /**
     * 系统用户
     */
    @TableField(value = "systemuserid")
    @JSONField(name = "systemuserid")
    @JsonProperty("systemuserid")
    private String systemuserid;
    /**
     * 元数据同步版本
     */
    @TableField(value = "metadatasynctimestamp")
    @JSONField(name = "metadatasynctimestamp")
    @JsonProperty("metadatasynctimestamp")
    private BigInteger metadatasynctimestamp;
    /**
     * 报告组名称
     */
    @TableField(value = "reportinggroupname")
    @JSONField(name = "reportinggroupname")
    @JsonProperty("reportinggroupname")
    private String reportinggroupname;
    /**
     * 自定义全局帮助是否已启用
     */
    @DEField(defaultValue = "1")
    @TableField(value = "globalhelpurlenabled")
    @JSONField(name = "globalhelpurlenabled")
    @JsonProperty("globalhelpurlenabled")
    private Integer globalhelpurlenabled;
    /**
     * 客户端功能集
     */
    @TableField(value = "clientfeatureset")
    @JSONField(name = "clientfeatureset")
    @JsonProperty("clientfeatureset")
    private String clientfeatureset;
    /**
     * 委派的管理员
     */
    @TableField(value = "delegatedadminuserid")
    @JSONField(name = "delegatedadminuserid")
    @JsonProperty("delegatedadminuserid")
    private String delegatedadminuserid;
    /**
     * 插件跟踪日志设置
     */
    @TableField(value = "plugintracelogsetting")
    @JSONField(name = "plugintracelogsetting")
    @JsonProperty("plugintracelogsetting")
    private String plugintracelogsetting;
    /**
     * 汇总目标的到期时间
     */
    @TableField(value = "goalrollupexpirytime")
    @JSONField(name = "goalrollupexpirytime")
    @JsonProperty("goalrollupexpirytime")
    private Integer goalrollupexpirytime;
    /**
     * 显示导航教程
     */
    @DEField(defaultValue = "1")
    @TableField(value = "displaynavigationtour")
    @JSONField(name = "displaynavigationtour")
    @JsonProperty("displaynavigationtour")
    private Integer displaynavigationtour;
    /**
     * 捆绑销售项限制
     */
    @TableField(value = "maxproductsinbundle")
    @JSONField(name = "maxproductsinbundle")
    @JsonProperty("maxproductsinbundle")
    private Integer maxproductsinbundle;
    /**
     * ISV 集成模式
     */
    @TableField(value = "isvintegrationcode")
    @JSONField(name = "isvintegrationcode")
    @JsonProperty("isvintegrationcode")
    private String isvintegrationcode;
    /**
     * Dynamics 365 azure sync 的选择加入操作或选择退出操作的状态。
     */
    @TableField(value = "syncoptinselectionstatus")
    @JSONField(name = "syncoptinselectionstatus")
    @JsonProperty("syncoptinselectionstatus")
    private String syncoptinselectionstatus;
    /**
     * 启用创建时定价
     */
    @DEField(defaultValue = "1")
    @TableField(value = "enablepricingoncreate")
    @JSONField(name = "enablepricingoncreate")
    @JsonProperty("enablepricingoncreate")
    private Integer enablepricingoncreate;
    /**
     * 哈希筛选关键字
     */
    @TableField(value = "hashfilterkeywords")
    @JSONField(name = "hashfilterkeywords")
    @JsonProperty("hashfilterkeywords")
    private String hashfilterkeywords;
    /**
     * AM 指示符
     */
    @TableField(value = "amdesignator")
    @JSONField(name = "amdesignator")
    @JsonProperty("amdesignator")
    private String amdesignator;
    /**
     * 允许脱机计划同步
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowofflinescheduledsyncs")
    @JSONField(name = "allowofflinescheduledsyncs")
    @JsonProperty("allowofflinescheduledsyncs")
    private Integer allowofflinescheduledsyncs;
    /**
     * 默认 Mobile Offline 配置文件
     */
    @TableField(value = "defaultmobileofflineprofileid")
    @JSONField(name = "defaultmobileofflineprofileid")
    @JsonProperty("defaultmobileofflineprofileid")
    private String defaultmobileofflineprofileid;
    /**
     * 负数格式
     */
    @TableField(value = "negativeformatcode")
    @JSONField(name = "negativeformatcode")
    @JsonProperty("negativeformatcode")
    private String negativeformatcode;
    /**
     * 批量操作前缀
     */
    @TableField(value = "bulkoperationprefix")
    @JSONField(name = "bulkoperationprefix")
    @JsonProperty("bulkoperationprefix")
    private String bulkoperationprefix;
    /**
     * 当前合同号
     */
    @TableField(value = "currentcontractnumber")
    @JSONField(name = "currentcontractnumber")
    @JsonProperty("currentcontractnumber")
    private Integer currentcontractnumber;
    /**
     * MSTeamsCollaborationEnabled
     */
    @DEField(defaultValue = "0")
    @TableField(value = "msteamscollaborationenabled")
    @JSONField(name = "msteamscollaborationenabled")
    @JsonProperty("msteamscollaborationenabled")
    private Integer msteamscollaborationenabled;
    /**
     * 启用外部文件存储
     */
    @DEField(defaultValue = "0")
    @TableField(value = "externalfilestorageenabled")
    @JSONField(name = "externalfilestorageenabled")
    @JsonProperty("externalfilestorageenabled")
    private Integer externalfilestorageenabled;
    /**
     * 令牌密钥
     */
    @TableField(value = "tokenkey")
    @JSONField(name = "tokenkey")
    @JsonProperty("tokenkey")
    private String tokenkey;
    /**
     * 当前发票编号
     */
    @TableField(value = "currentinvoicenumber")
    @JSONField(name = "currentinvoicenumber")
    @JsonProperty("currentinvoicenumber")
    private Integer currentinvoicenumber;
    /**
     * SQL 访问组名称
     */
    @TableField(value = "sqlaccessgroupname")
    @JSONField(name = "sqlaccessgroupname")
    @JsonProperty("sqlaccessgroupname")
    private String sqlaccessgroupname;
    /**
     * 货币小数精度
     */
    @TableField(value = "currencydecimalprecision")
    @JSONField(name = "currencydecimalprecision")
    @JsonProperty("currencydecimalprecision")
    private Integer currencydecimalprecision;
    /**
     * 会话超时提醒(以分钟为单位)
     */
    @TableField(value = "sessiontimeoutreminderinmins")
    @JSONField(name = "sessiontimeoutreminderinmins")
    @JsonProperty("sessiontimeoutreminderinmins")
    private Integer sessiontimeoutreminderinmins;
    /**
     * 联机状态下每个实体所允许的可用 SLA 的最大数量
     */
    @TableField(value = "maximumentitieswithactivesla")
    @JSONField(name = "maximumentitieswithactivesla")
    @JsonProperty("maximumentitieswithactivesla")
    private Integer maximumentitieswithactivesla;
    /**
     * 为手动替代后自动应用 SLA
     */
    @DEField(defaultValue = "0")
    @TableField(value = "autoapplysla")
    @JSONField(name = "autoapplysla")
    @JsonProperty("autoapplysla")
    private Integer autoapplysla;
    /**
     * 节假日日历
     */
    @TableField(value = "businessclosurecalendarid")
    @JSONField(name = "businessclosurecalendarid")
    @JsonProperty("businessclosurecalendarid")
    private String businessclosurecalendarid;
    /**
     * 为此组织启用 One Drive
     */
    @DEField(defaultValue = "0")
    @TableField(value = "onedriveenabled")
    @JSONField(name = "onedriveenabled")
    @JsonProperty("onedriveenabled")
    private Integer onedriveenabled;
    /**
     * 会计年度格式
     */
    @TableField(value = "fiscalyearformat")
    @JSONField(name = "fiscalyearformat")
    @JsonProperty("fiscalyearformat")
    private String fiscalyearformat;
    /**
     * Mobile Offline 的同步间隔。
     */
    @TableField(value = "mobileofflinesyncinterval")
    @JSONField(name = "mobileofflinesyncinterval")
    @JsonProperty("mobileofflinesyncinterval")
    private Integer mobileofflinesyncinterval;
    /**
     * 参考站点地图 XML
     */
    @TableField(value = "referencesitemapxml")
    @JSONField(name = "referencesitemapxml")
    @JsonProperty("referencesitemapxml")
    private String referencesitemapxml;
    /**
     * 已启用会话超时
     */
    @DEField(defaultValue = "0")
    @TableField(value = "sessiontimeoutenabled")
    @JSONField(name = "sessiontimeoutenabled")
    @JsonProperty("sessiontimeoutenabled")
    private Integer sessiontimeoutenabled;
    /**
     * 当前已解析表的编号
     */
    @TableField(value = "currentparsedtablenumber")
    @JSONField(name = "currentparsedtablenumber")
    @JsonProperty("currentparsedtablenumber")
    private Integer currentparsedtablenumber;
    /**
     * 组织名称
     */
    @TableField(value = "organizationname")
    @JSONField(name = "organizationname")
    @JsonProperty("organizationname")
    private String organizationname;
    /**
     * 数字分组格式
     */
    @TableField(value = "numbergroupformat")
    @JSONField(name = "numbergroupformat")
    @JsonProperty("numbergroupformat")
    private String numbergroupformat;
    /**
     * 功能集
     */
    @TableField(value = "featureset")
    @JSONField(name = "featureset")
    @JsonProperty("featureset")
    private String featureset;
    /**
     * 启动会计日历
     */
    @TableField(value = "fiscalcalendarstart")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "fiscalcalendarstart" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("fiscalcalendarstart")
    private Timestamp fiscalcalendarstart;
    /**
     * 数字格式
     */
    @TableField(value = "numberformat")
    @JSONField(name = "numberformat")
    @JsonProperty("numberformat")
    private String numberformat;
    /**
     * 不活动超时时间(以分钟为单位)
     */
    @TableField(value = "inactivitytimeoutinmins")
    @JSONField(name = "inactivitytimeoutinmins")
    @JsonProperty("inactivitytimeoutinmins")
    private Integer inactivitytimeoutinmins;
    /**
     * 允许跟踪有关已发送电子邮件的收件人活动
     */
    @DEField(defaultValue = "1")
    @TableField(value = "emailmonitoringallowed")
    @JSONField(name = "emailmonitoringallowed")
    @JsonProperty("emailmonitoringallowed")
    private Integer emailmonitoringallowed;
    /**
     * 会计年度期间连接器
     */
    @TableField(value = "fiscalyearperiodconnect")
    @JSONField(name = "fiscalyearperiodconnect")
    @JsonProperty("fiscalyearperiodconnect")
    private String fiscalyearperiodconnect;
    /**
     * 是否启用重复检测
     */
    @DEField(defaultValue = "0")
    @TableField(value = "duplicatedetectionenabled")
    @JSONField(name = "duplicatedetectionenabled")
    @JsonProperty("duplicatedetectionenabled")
    private Integer duplicatedetectionenabled;
    /**
     * 已启用社交透析
     */
    @DEField(defaultValue = "0")
    @TableField(value = "socialinsightsenabled")
    @JSONField(name = "socialinsightsenabled")
    @JsonProperty("socialinsightsenabled")
    private Integer socialinsightsenabled;
    /**
     * 默认重复结束范围类型
     */
    @TableField(value = "defaultrecurrenceendrangetype")
    @JSONField(name = "defaultrecurrenceendrangetype")
    @JsonProperty("defaultrecurrenceendrangetype")
    private String defaultrecurrenceendrangetype;
    /**
     * 默认国家/地区代码
     */
    @TableField(value = "defaultcountrycode")
    @JSONField(name = "defaultcountrycode")
    @JsonProperty("defaultcountrycode")
    private String defaultcountrycode;
    /**
     * 为此组织启用预览操作卡功能
     */
    @DEField(defaultValue = "0")
    @TableField(value = "previewenabledforactioncard")
    @JSONField(name = "previewenabledforactioncard")
    @JsonProperty("previewenabledforactioncard")
    private Integer previewenabledforactioncard;
    /**
     * 会计年度格式(年)
     */
    @TableField(value = "fiscalyearformatyear")
    @JSONField(name = "fiscalyearformatyear")
    @JsonProperty("fiscalyearformatyear")
    private String fiscalyearformatyear;
    /**
     * 启用或禁用国家/地区代码选择
     */
    @DEField(defaultValue = "1")
    @TableField(value = "defaultcountrycodecheckenabled")
    @JSONField(name = "defaultcountrycodecheckenabled")
    @JsonProperty("defaultcountrycodecheckenabled")
    private Integer defaultcountrycodecheckenabled;
    /**
     * 将来的扩展窗口
     */
    @TableField(value = "futureexpansionwindow")
    @JSONField(name = "futureexpansionwindow")
    @JsonProperty("futureexpansionwindow")
    private Integer futureexpansionwindow;
    /**
     * 限制状态更新
     */
    @DEField(defaultValue = "0")
    @TableField(value = "restrictstatusupdate")
    @JSONField(name = "restrictstatusupdate")
    @JsonProperty("restrictstatusupdate")
    private Integer restrictstatusupdate;
    /**
     * 当前导入序列号
     */
    @TableField(value = "currentimportsequencenumber")
    @JSONField(name = "currentimportsequencenumber")
    @JsonProperty("currentimportsequencenumber")
    private Integer currentimportsequencenumber;
    /**
     * 示例数据导入
     */
    @TableField(value = "sampledataimportid")
    @JSONField(name = "sampledataimportid")
    @JsonProperty("sampledataimportid")
    private String sampledataimportid;
    /**
     * 是否启用审核功能
     */
    @DEField(defaultValue = "0")
    @TableField(value = "auditenabled")
    @JSONField(name = "auditenabled")
    @JsonProperty("auditenabled")
    private Integer auditenabled;
    /**
     * 允许自动取消预订
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowautounsubscribe")
    @JSONField(name = "allowautounsubscribe")
    @JsonProperty("allowautounsubscribe")
    private Integer allowautounsubscribe;
    /**
     * 约会和服务活动的计划引擎
     */
    @TableField(value = "schedulingengine")
    @JSONField(name = "schedulingengine")
    @JsonProperty("schedulingengine")
    private String schedulingengine;
    /**
     * MSTeamsEnabled
     */
    @DEField(defaultValue = "0")
    @TableField(value = "msteamsenabled")
    @JSONField(name = "msteamsenabled")
    @JsonProperty("msteamsenabled")
    private Integer msteamsenabled;
    /**
     * 启用智能匹配
     */
    @DEField(defaultValue = "0")
    @TableField(value = "enablesmartmatching")
    @JSONField(name = "enablesmartmatching")
    @JsonProperty("enablesmartmatching")
    private Integer enablesmartmatching;
    /**
     * 订单前缀
     */
    @TableField(value = "orderprefix")
    @JSONField(name = "orderprefix")
    @JsonProperty("orderprefix")
    private String orderprefix;
    /**
     * UTC 转换时区代码
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * 在预览设置中为此组织启用自动捕获功能
     */
    @DEField(defaultValue = "0")
    @TableField(value = "previewforautocaptureenabled")
    @JSONField(name = "previewforautocaptureenabled")
    @JsonProperty("previewforautocaptureenabled")
    private Integer previewforautocaptureenabled;
    /**
     * 默认应用程序的名称
     */
    @TableField(value = "defaultcrmcustomname")
    @JSONField(name = "defaultcrmcustomname")
    @JsonProperty("defaultcrmcustomname")
    private String defaultcrmcustomname;
    /**
     * 日期格式代码
     */
    @TableField(value = "dateformatcode")
    @JSONField(name = "dateformatcode")
    @JsonProperty("dateformatcode")
    private String dateformatcode;
    /**
     * 报告脚本错误
     */
    @TableField(value = "reportscripterrors")
    @JSONField(name = "reportscripterrors")
    @JsonProperty("reportscripterrors")
    private String reportscripterrors;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 为此组织启用 OfficeGraph
     */
    @DEField(defaultValue = "0")
    @TableField(value = "officegraphenabled")
    @JSONField(name = "officegraphenabled")
    @JsonProperty("officegraphenabled")
    private Integer officegraphenabled;
    /**
     * 组织
     */
    @DEField(isKeyField=true)
    @TableId(value= "organizationid",type=IdType.UUID)
    @JSONField(name = "organizationid")
    @JsonProperty("organizationid")
    private String organizationid;
    /**
     * isenabledforallroles 的选项集值
     */
    @DEField(defaultValue = "1")
    @TableField(value = "enabledforallroles")
    @JSONField(name = "enabledforallroles")
    @JsonProperty("enabledforallroles")
    private Integer enabledforallroles;
    /**
     * 跟踪令牌位数
     */
    @TableField(value = "trackingtokeniddigits")
    @JSONField(name = "trackingtokeniddigits")
    @JsonProperty("trackingtokeniddigits")
    private Integer trackingtokeniddigits;
    /**
     * 是否禁用 Social Care
     */
    @DEField(defaultValue = "0")
    @TableField(value = "disablesocialcare")
    @JSONField(name = "disablesocialcare")
    @JsonProperty("disablesocialcare")
    private Integer disablesocialcare;
    /**
     * 用于强制只读插件的组织设置。
     */
    @DEField(defaultValue = "0")
    @TableField(value = "enforcereadonlyplugins")
    @JSONField(name = "enforcereadonlyplugins")
    @JsonProperty("enforcereadonlyplugins")
    private Integer enforcereadonlyplugins;
    /**
     * 日期分隔符
     */
    @TableField(value = "dateseparator")
    @JSONField(name = "dateseparator")
    @JsonProperty("dateseparator")
    private String dateseparator;
    /**
     * 为隐藏 SLA
     */
    @DEField(defaultValue = "0")
    @TableField(value = "suppresssla")
    @JSONField(name = "suppresssla")
    @JsonProperty("suppresssla")
    private Integer suppresssla;
    /**
     * 用户身份验证审核时间间隔
     */
    @TableField(value = "useraccessauditinginterval")
    @JSONField(name = "useraccessauditinginterval")
    @JsonProperty("useraccessauditinginterval")
    private Integer useraccessauditinginterval;
    /**
     * 长日期格式
     */
    @TableField(value = "longdateformatcode")
    @JSONField(name = "longdateformatcode")
    @JsonProperty("longdateformatcode")
    private Integer longdateformatcode;
    /**
     * 使用读优化窗体
     */
    @DEField(defaultValue = "0")
    @TableField(value = "usereadform")
    @JSONField(name = "usereadform")
    @JsonProperty("usereadform")
    private Integer usereadform;
    /**
     * AllowLegacyClientExperience
     */
    @DEField(defaultValue = "1")
    @TableField(value = "allowlegacyclientexperience")
    @JSONField(name = "allowlegacyclientexperience")
    @JsonProperty("allowlegacyclientexperience")
    private Integer allowlegacyclientexperience;
    /**
     * 为此组织启用 Dynamics 365 azure sync 框架。
     */
    @DEField(defaultValue = "0")
    @TableField(value = "syncoptinselection")
    @JSONField(name = "syncoptinselection")
    @JsonProperty("syncoptinselection")
    private Integer syncoptinselection;
    /**
     * MSTeamsSettingChangedByUser
     */
    @DEField(defaultValue = "0")
    @TableField(value = "msteamssettingchangedbyuser")
    @JSONField(name = "msteamssettingchangedbyuser")
    @JsonProperty("msteamssettingchangedbyuser")
    private Integer msteamssettingchangedbyuser;
    /**
     * 允许计划同步
     */
    @DEField(defaultValue = "0")
    @TableField(value = "allowoutlookscheduledsyncs")
    @JSONField(name = "allowoutlookscheduledsyncs")
    @JsonProperty("allowoutlookscheduledsyncs")
    private Integer allowoutlookscheduledsyncs;
    /**
     * 货币格式代码
     */
    @TableField(value = "currencyformatcode")
    @JSONField(name = "currencyformatcode")
    @JsonProperty("currencyformatcode")
    private String currencyformatcode;
    /**
     * 站点地图 XML
     */
    @TableField(value = "sitemapxml")
    @JSONField(name = "sitemapxml")
    @JsonProperty("sitemapxml")
    private String sitemapxml;
    /**
     * V3 标注哈希
     */
    @TableField(value = "v3calloutconfighash")
    @JSONField(name = "v3calloutconfighash")
    @JsonProperty("v3calloutconfighash")
    private String v3calloutconfighash;
    /**
     * 仅供内部使用
     */
    @TableField(value = "yammerpostmethod")
    @JSONField(name = "yammerpostmethod")
    @JsonProperty("yammerpostmethod")
    private String yammerpostmethod;
    /**
     * 市场活动前缀
     */
    @TableField(value = "campaignprefix")
    @JSONField(name = "campaignprefix")
    @JsonProperty("campaignprefix")
    private String campaignprefix;
    /**
     * 使用位置层次结构
     */
    @DEField(defaultValue = "0")
    @TableField(value = "usepositionhierarchy")
    @JSONField(name = "usepositionhierarchy")
    @JsonProperty("usepositionhierarchy")
    private Integer usepositionhierarchy;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * 允许用户窗体模式首选项
     */
    @DEField(defaultValue = "1")
    @TableField(value = "allowuserformmodepreference")
    @JSONField(name = "allowuserformmodepreference")
    @JsonProperty("allowuserformmodepreference")
    private Integer allowuserformmodepreference;
    /**
     * 是否启用基于文件夹的跟踪
     */
    @DEField(defaultValue = "0")
    @TableField(value = "folderbasedtrackingenabled")
    @JSONField(name = "folderbasedtrackingenabled")
    @JsonProperty("folderbasedtrackingenabled")
    private Integer folderbasedtrackingenabled;
    /**
     * 是否更新会计设置
     */
    @DEField(defaultValue = "0")
    @TableField(value = "fiscalsettingsupdated")
    @JSONField(name = "fiscalsettingsupdated")
    @JsonProperty("fiscalsettingsupdated")
    private Integer fiscalsettingsupdated;
    /**
     * 授予网络服务访问权限
     */
    @DEField(defaultValue = "0")
    @TableField(value = "grantaccesstonetworkservice")
    @JSONField(name = "grantaccesstonetworkservice")
    @JsonProperty("grantaccesstonetworkservice")
    private Integer grantaccesstonetworkservice;
    /**
     * 为此组织启用 Relationship Insights
     */
    @DEField(defaultValue = "0")
    @TableField(value = "relationshipinsightsenabled")
    @JSONField(name = "relationshipinsightsenabled")
    @JsonProperty("relationshipinsightsenabled")
    private Integer relationshipinsightsenabled;
    /**
     * 允许导出至 Excel
     */
    @DEField(defaultValue = "1")
    @TableField(value = "allowwebexcelexport")
    @JSONField(name = "allowwebexcelexport")
    @JsonProperty("allowwebexcelexport")
    private Integer allowwebexcelexport;
    /**
     * 周起始日代码
     */
    @TableField(value = "weekstartdaycode")
    @JSONField(name = "weekstartdaycode")
    @JsonProperty("weekstartdaycode")
    private String weekstartdaycode;
    /**
     * 版本号
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * SyncBulkOperationBatchSize
     */
    @TableField(value = "syncbulkoperationbatchsize")
    @JSONField(name = "syncbulkoperationbatchsize")
    @JsonProperty("syncbulkoperationbatchsize")
    private Integer syncbulkoperationbatchsize;
    /**
     * 社交透析实例标识符
     */
    @TableField(value = "socialinsightsinstance")
    @JSONField(name = "socialinsightsinstance")
    @JsonProperty("socialinsightsinstance")
    private String socialinsightsinstance;
    /**
     * 启用快速查找的全文搜索
     */
    @DEField(defaultValue = "1")
    @TableField(value = "fulltextsearchenabled")
    @JSONField(name = "fulltextsearchenabled")
    @JsonProperty("fulltextsearchenabled")
    private Integer fulltextsearchenabled;
    /**
     * 为详细日志记录启用的邮箱的最大数量
     */
    @TableField(value = "maxverboseloggingmailbox")
    @JSONField(name = "maxverboseloggingmailbox")
    @JsonProperty("maxverboseloggingmailbox")
    private Integer maxverboseloggingmailbox;
    /**
     * 权限报告组
     */
    @TableField(value = "privreportinggroupid")
    @JSONField(name = "privreportinggroupid")
    @JsonProperty("privreportinggroupid")
    private String privreportinggroupid;
    /**
     * 启用文本换行
     */
    @DEField(defaultValue = "1")
    @TableField(value = "textwrapenabled")
    @JSONField(name = "textwrapenabled")
    @JsonProperty("textwrapenabled")
    private Integer textwrapenabled;
    /**
     * 禁用的原因
     */
    @TableField(value = "disabledreason")
    @JSONField(name = "disabledreason")
    @JsonProperty("disabledreason")
    private String disabledreason;
    /**
     * 自动标记最大周期数
     */
    @TableField(value = "tagmaxaggressivecycles")
    @JSONField(name = "tagmaxaggressivecycles")
    @JsonProperty("tagmaxaggressivecycles")
    private Integer tagmaxaggressivecycles;
    /**
     * 生成警告警报
     */
    @DEField(defaultValue = "1")
    @TableField(value = "generatealertsforwarnings")
    @JSONField(name = "generatealertsforwarnings")
    @JsonProperty("generatealertsforwarnings")
    private Integer generatealertsforwarnings;
    /**
     * 知识文章前缀
     */
    @TableField(value = "kaprefix")
    @JSONField(name = "kaprefix")
    @JsonProperty("kaprefix")
    private String kaprefix;
    /**
     * 初始版本
     */
    @TableField(value = "initialversion")
    @JSONField(name = "initialversion")
    @JsonProperty("initialversion")
    private String initialversion;
    /**
     * 时区规则版本号
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * 已解析表列的前缀
     */
    @TableField(value = "parsedtablecolumnprefix")
    @JSONField(name = "parsedtablecolumnprefix")
    @JsonProperty("parsedtablecolumnprefix")
    private String parsedtablecolumnprefix;
    /**
     * 显示周数
     */
    @DEField(defaultValue = "0")
    @TableField(value = "showweeknumber")
    @JSONField(name = "showweeknumber")
    @JsonProperty("showweeknumber")
    private Integer showweeknumber;
    /**
     * 为此组织启用产品建议
     */
    @DEField(defaultValue = "0")
    @TableField(value = "productrecommendationsenabled")
    @JSONField(name = "productrecommendationsenabled")
    @JsonProperty("productrecommendationsenabled")
    private Integer productrecommendationsenabled;
    /**
     * 使用电子邮件相关性
     */
    @DEField(defaultValue = "1")
    @TableField(value = "emailcorrelationenabled")
    @JSONField(name = "emailcorrelationenabled")
    @JsonProperty("emailcorrelationenabled")
    private Integer emailcorrelationenabled;
    /**
     * 集成用户
     */
    @TableField(value = "integrationuserid")
    @JSONField(name = "integrationuserid")
    @JsonProperty("integrationuserid")
    private String integrationuserid;
    /**
     * 哈希最大计数
     */
    @TableField(value = "hashmaxcount")
    @JSONField(name = "hashmaxcount")
    @JsonProperty("hashmaxcount")
    private Integer hashmaxcount;
    /**
     * 报价单前缀
     */
    @TableField(value = "quoteprefix")
    @JSONField(name = "quoteprefix")
    @JsonProperty("quoteprefix")
    private String quoteprefix;
    /**
     * 案例前缀
     */
    @TableField(value = "caseprefix")
    @JSONField(name = "caseprefix")
    @JsonProperty("caseprefix")
    private String caseprefix;
    /**
     * PinpointLanguageCode
     */
    @TableField(value = "pinpointlanguagecode")
    @JSONField(name = "pinpointlanguagecode")
    @JsonProperty("pinpointlanguagecode")
    private Integer pinpointlanguagecode;
    /**
     * 货币负数格式
     */
    @TableField(value = "negativecurrencyformatcode")
    @JSONField(name = "negativecurrencyformatcode")
    @JsonProperty("negativecurrencyformatcode")
    private Integer negativecurrencyformatcode;
    /**
     * 是否启用入门窗格内容
     */
    @DEField(defaultValue = "1")
    @TableField(value = "getstartedpanecontentenabled")
    @JSONField(name = "getstartedpanecontentenabled")
    @JsonProperty("getstartedpanecontentenabled")
    private Integer getstartedpanecontentenabled;
    /**
     * 最大跟踪号
     */
    @TableField(value = "maximumtrackingnumber")
    @JSONField(name = "maximumtrackingnumber")
    @JsonProperty("maximumtrackingnumber")
    private Integer maximumtrackingnumber;
    /**
     * 会计年度前缀
     */
    @TableField(value = "fiscalyearformatprefix")
    @JSONField(name = "fiscalyearformatprefix")
    @JsonProperty("fiscalyearformatprefix")
    private String fiscalyearformatprefix;
    /**
     * 实体图像
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * 数字分隔符
     */
    @TableField(value = "numberseparator")
    @JSONField(name = "numberseparator")
    @JsonProperty("numberseparator")
    private String numberseparator;
    /**
     * 发票前缀
     */
    @TableField(value = "invoiceprefix")
    @JSONField(name = "invoiceprefix")
    @JsonProperty("invoiceprefix")
    private String invoiceprefix;
    /**
     * 在创建服务案例时自动应用默认权利
     */
    @DEField(defaultValue = "0")
    @TableField(value = "autoapplydefaultoncasecreate")
    @JSONField(name = "autoapplydefaultoncasecreate")
    @JsonProperty("autoapplydefaultoncasecreate")
    private Integer autoapplydefaultoncasecreate;
    /**
     * 实体图像 ID
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * 权限用户组
     */
    @TableField(value = "privilegeusergroupid")
    @JSONField(name = "privilegeusergroupid")
    @JsonProperty("privilegeusergroupid")
    private String privilegeusergroupid;
    /**
     * 忽略 Internal 电子邮件
     */
    @DEField(defaultValue = "0")
    @TableField(value = "ignoreinternalemail")
    @JSONField(name = "ignoreinternalemail")
    @JsonProperty("ignoreinternalemail")
    private Integer ignoreinternalemail;
    /**
     * 货币显示格式
     */
    @TableField(value = "currencydisplayoption")
    @JSONField(name = "currencydisplayoption")
    @JsonProperty("currencydisplayoption")
    private String currencydisplayoption;
    /**
     * 默认主题数据
     */
    @TableField(value = "defaultthemedata")
    @JSONField(name = "defaultthemedata")
    @JsonProperty("defaultthemedata")
    private String defaultthemedata;
    /**
     * 当前知识文章编号
     */
    @TableField(value = "currentkanumber")
    @JSONField(name = "currentkanumber")
    @JsonProperty("currentkanumber")
    private Integer currentkanumber;
    /**
     * 排序
     */
    @TableField(value = "sortid")
    @JSONField(name = "sortid")
    @JsonProperty("sortid")
    private Integer sortid;
    /**
     * Bing 地图 API 密钥
     */
    @TableField(value = "bingmapsapikey")
    @JSONField(name = "bingmapsapikey")
    @JsonProperty("bingmapsapikey")
    private String bingmapsapikey;
    /**
     * 全局帮助 URL。
     */
    @TableField(value = "globalhelpurl")
    @JSONField(name = "globalhelpurl")
    @JsonProperty("globalhelpurl")
    private String globalhelpurl;
    /**
     * 级联状态更新
     */
    @DEField(defaultValue = "0")
    @TableField(value = "cascadestatusupdate")
    @JSONField(name = "cascadestatusupdate")
    @JsonProperty("cascadestatusupdate")
    private Integer cascadestatusupdate;
    /**
     * 照片
     */
    @TableField(value = "picture")
    @JSONField(name = "picture")
    @JsonProperty("picture")
    private String picture;
    /**
     * 自动标记时间间隔
     */
    @TableField(value = "tagpollingperiod")
    @JSONField(name = "tagpollingperiod")
    @JsonProperty("tagpollingperiod")
    private Integer tagpollingperiod;
    /**
     * 更改跟踪已删除的记录到期前的天数
     */
    @TableField(value = "expirechangetrackingindays")
    @JSONField(name = "expirechangetrackingindays")
    @JsonProperty("expirechangetrackingindays")
    private Integer expirechangetrackingindays;
    /**
     * 跟踪前缀
     */
    @TableField(value = "trackingprefix")
    @JSONField(name = "trackingprefix")
    @JsonProperty("trackingprefix")
    private String trackingprefix;
    /**
     * 显示会计年度
     */
    @TableField(value = "fiscalyeardisplaycode")
    @JSONField(name = "fiscalyeardisplaycode")
    @JsonProperty("fiscalyeardisplaycode")
    private Integer fiscalyeardisplaycode;
    /**
     * 上载文件最大大小
     */
    @TableField(value = "maxuploadfilesize")
    @JSONField(name = "maxuploadfilesize")
    @JsonProperty("maxuploadfilesize")
    private Integer maxuploadfilesize;
    /**
     * 为此组织启用操作卡
     */
    @DEField(defaultValue = "0")
    @TableField(value = "actioncardenabled")
    @JSONField(name = "actioncardenabled")
    @JsonProperty("actioncardenabled")
    private Integer actioncardenabled;
    /**
     * 会话超时时间(以分钟为单位)
     */
    @TableField(value = "sessiontimeoutinmins")
    @JSONField(name = "sessiontimeoutinmins")
    @JsonProperty("sessiontimeoutinmins")
    private Integer sessiontimeoutinmins;
    /**
     * SyncBulkOperationMaxLimit
     */
    @TableField(value = "syncbulkoperationmaxlimit")
    @JSONField(name = "syncbulkoperationmaxlimit")
    @JsonProperty("syncbulkoperationmaxlimit")
    private Integer syncbulkoperationmaxlimit;
    /**
     * 邮箱强制解锁是否启用
     */
    @DEField(defaultValue = "0")
    @TableField(value = "mailboxforcedunlockingenabled")
    @JSONField(name = "mailboxforcedunlockingenabled")
    @JsonProperty("mailboxforcedunlockingenabled")
    private Integer mailboxforcedunlockingenabled;
    /**
     * 基础货币精度
     */
    @TableField(value = "basecurrencyprecision")
    @JSONField(name = "basecurrencyprecision")
    @JsonProperty("basecurrencyprecision")
    private Integer basecurrencyprecision;
    /**
     * 地址同步最低频率
     */
    @TableField(value = "minaddressbooksyncinterval")
    @JSONField(name = "minaddressbooksyncinterval")
    @JsonProperty("minaddressbooksyncinterval")
    private Integer minaddressbooksyncinterval;
    /**
     * 启用 Bing 地图集成
     */
    @DEField(defaultValue = "1")
    @TableField(value = "enablebingmapsintegration")
    @JSONField(name = "enablebingmapsintegration")
    @JsonProperty("enablebingmapsintegration")
    private Integer enablebingmapsintegration;
    /**
     * 是否启用邮箱保持连接
     */
    @DEField(defaultValue = "0")
    @TableField(value = "mailboxinactivebackoffenabled")
    @JSONField(name = "mailboxinactivebackoffenabled")
    @JsonProperty("mailboxinactivebackoffenabled")
    private Integer mailboxinactivebackoffenabled;
    /**
     * 快速查找记录限制已启用
     */
    @DEField(defaultValue = "1")
    @TableField(value = "quickfindrecordlimitenabled")
    @JSONField(name = "quickfindrecordlimitenabled")
    @JsonProperty("quickfindrecordlimitenabled")
    private Integer quickfindrecordlimitenabled;
    /**
     * 会计期间的格式
     */
    @TableField(value = "fiscalperiodformatperiod")
    @JSONField(name = "fiscalperiodformatperiod")
    @JsonProperty("fiscalperiodformatperiod")
    private String fiscalperiodformatperiod;
    /**
     * 文章前缀
     */
    @TableField(value = "kbprefix")
    @JSONField(name = "kbprefix")
    @JsonProperty("kbprefix")
    private String kbprefix;
    /**
     * PM 指示符
     */
    @TableField(value = "pmdesignator")
    @JSONField(name = "pmdesignator")
    @JsonProperty("pmdesignator")
    private String pmdesignator;
    /**
     * 确认模板
     */
    @TableField(value = "acknowledgementtemplateid")
    @JSONField(name = "acknowledgementtemplateid")
    @JsonProperty("acknowledgementtemplateid")
    private String acknowledgementtemplateid;
    /**
     * 货币
     */
    @TableField(value = "basecurrencyid")
    @JSONField(name = "basecurrencyid")
    @JsonProperty("basecurrencyid")
    private String basecurrencyid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Template acknowledgementtemplate;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency basecurrency;



    /**
     * 设置 [EnableLivePersonaCardUCI]
     */
    public void setEnablelivepersonacarduci(Integer enablelivepersonacarduci){
        this.enablelivepersonacarduci = enablelivepersonacarduci ;
        this.modify("enablelivepersonacarduci",enablelivepersonacarduci);
    }

    /**
     * 设置 [为此组织启用自动捕获]
     */
    public void setAutodatacaptureenabled(Integer autodatacaptureenabled){
        this.autodatacaptureenabled = autodatacaptureenabled ;
        this.modify("autodatacaptureenabled",autodatacaptureenabled);
    }

    /**
     * 设置 [允许 Outlook 客户端消息栏广告]
     */
    public void setAllowclientmessagebarad(Integer allowclientmessagebarad){
        this.allowclientmessagebarad = allowclientmessagebarad ;
        this.modify("allowclientmessagebarad",allowclientmessagebarad);
    }

    /**
     * 设置 [Yammer 组 ID]
     */
    public void setYammergroupid(Integer yammergroupid){
        this.yammergroupid = yammergroupid ;
        this.modify("yammergroupid",yammergroupid);
    }

    /**
     * 设置 [目标的自动汇总频率]
     */
    public void setGoalrollupfrequency(Integer goalrollupfrequency){
        this.goalrollupfrequency = goalrollupfrequency ;
        this.modify("goalrollupfrequency",goalrollupfrequency);
    }

    /**
     * 设置 [年起始周代码]
     */
    public void setYearstartweekcode(Integer yearstartweekcode){
        this.yearstartweekcode = yearstartweekcode ;
        this.modify("yearstartweekcode",yearstartweekcode);
    }

    /**
     * 设置 [启用 OOB 价格计算]
     */
    public void setOobpricecalculationenabled(Integer oobpricecalculationenabled){
        this.oobpricecalculationenabled = oobpricecalculationenabled ;
        this.modify("oobpricecalculationenabled",oobpricecalculationenabled);
    }

    /**
     * 设置 [为此组织启用应用程序设计器体验]
     */
    public void setAppdesignerexperienceenabled(Integer appdesignerexperienceenabled){
        this.appdesignerexperienceenabled = appdesignerexperienceenabled ;
        this.modify("appdesignerexperienceenabled",appdesignerexperienceenabled);
    }

    /**
     * 设置 [旧窗体呈现]
     */
    public void setUselegacyrendering(Integer uselegacyrendering){
        this.uselegacyrendering = uselegacyrendering ;
        this.modify("uselegacyrendering",uselegacyrendering);
    }

    /**
     * 设置 [Web 资源哈希]
     */
    public void setWebresourcehash(String webresourcehash){
        this.webresourcehash = webresourcehash ;
        this.modify("webresourcehash",webresourcehash);
    }

    /**
     * 设置 [用户 Skype 协议]
     */
    public void setUseskypeprotocol(Integer useskypeprotocol){
        this.useskypeprotocol = useskypeprotocol ;
        this.modify("useskypeprotocol",useskypeprotocol);
    }

    /**
     * 设置 [为此组织启用注释分析]
     */
    public void setNotesanalysisenabled(Integer notesanalysisenabled){
        this.notesanalysisenabled = notesanalysisenabled ;
        this.modify("notesanalysisenabled",notesanalysisenabled);
    }

    /**
     * 设置 [基础 ISO 货币代码]
     */
    public void setBaseisocurrencycode(String baseisocurrencycode){
        this.baseisocurrencycode = baseisocurrencycode ;
        this.modify("baseisocurrencycode",baseisocurrencycode);
    }

    /**
     * 设置 [区域设置]
     */
    public void setLocaleid(Integer localeid){
        this.localeid = localeid ;
        this.modify("localeid",localeid);
    }

    /**
     * 设置 [ExternalPartyEnabled 实体设置。仅供内部使用。]
     */
    public void setExternalpartyentitysettings(String externalpartyentitysettings){
        this.externalpartyentitysettings = externalpartyentitysettings ;
        this.modify("externalpartyentitysettings",externalpartyentitysettings);
    }

    /**
     * 设置 [启用与 Microsoft Flow 的集成]
     */
    public void setEnablemicrosoftflowintegration(Integer enablemicrosoftflowintegration){
        this.enablemicrosoftflowintegration = enablemicrosoftflowintegration ;
        this.modify("enablemicrosoftflowintegration",enablemicrosoftflowintegration);
    }

    /**
     * 设置 [是否禁用组织]
     */
    public void setDisabled(Integer disabled){
        this.disabled = disabled ;
        this.modify("disabled",disabled);
    }

    /**
     * 设置 [最低脱机同步频率]
     */
    public void setMinofflinesyncinterval(Integer minofflinesyncinterval){
        this.minofflinesyncinterval = minofflinesyncinterval ;
        this.modify("minofflinesyncinterval",minofflinesyncinterval);
    }

    /**
     * 设置 [允许实体级审核]
     */
    public void setAllowentityonlyaudit(Integer allowentityonlyaudit){
        this.allowentityonlyaudit = allowentityonlyaudit ;
        this.modify("allowentityonlyaudit",allowentityonlyaudit);
    }

    /**
     * 设置 [允许通讯簿同步]
     */
    public void setAllowaddressbooksyncs(Integer allowaddressbooksyncs){
        this.allowaddressbooksyncs = allowaddressbooksyncs ;
        this.modify("allowaddressbooksyncs",allowaddressbooksyncs);
    }

    /**
     * 设置 [会计年度后缀]
     */
    public void setFiscalyearformatsuffix(String fiscalyearformatsuffix){
        this.fiscalyearformatsuffix = fiscalyearformatsuffix ;
        this.modify("fiscalyearformatsuffix",fiscalyearformatsuffix);
    }

    /**
     * 设置 [为此组织启用任务流流程]
     */
    public void setTaskbasedflowenabled(Integer taskbasedflowenabled){
        this.taskbasedflowenabled = taskbasedflowenabled ;
        this.modify("taskbasedflowenabled",taskbasedflowenabled);
    }

    /**
     * 设置 [生产/预览组织的 Mobile Offline 服务所需的最小用户许可证数]
     */
    public void setMobileofflineminlicenseprod(Integer mobileofflineminlicenseprod){
        this.mobileofflineminlicenseprod = mobileofflineminlicenseprod ;
        this.modify("mobileofflineminlicenseprod",mobileofflineminlicenseprod);
    }

    /**
     * 设置 [下一个跟踪号]
     */
    public void setNexttrackingnumber(Integer nexttrackingnumber){
        this.nexttrackingnumber = nexttrackingnumber ;
        this.modify("nexttrackingnumber",nexttrackingnumber);
    }

    /**
     * 设置 [报告组]
     */
    public void setReportinggroupid(String reportinggroupid){
        this.reportinggroupid = reportinggroupid ;
        this.modify("reportinggroupid",reportinggroupid);
    }

    /**
     * 设置 [下一个实体类型代码]
     */
    public void setNextcustomobjecttypecode(Integer nextcustomobjecttypecode){
        this.nextcustomobjecttypecode = nextcustomobjecttypecode ;
        this.modify("nextcustomobjecttypecode",nextcustomobjecttypecode);
    }

    /**
     * 设置 [当前类别编号]
     */
    public void setCurrentcategorynumber(Integer currentcategorynumber){
        this.currentcategorynumber = currentcategorynumber ;
        this.modify("currentcategorynumber",currentcategorynumber);
    }

    /**
     * 设置 [支持用户]
     */
    public void setSupportuserid(String supportuserid){
        this.supportuserid = supportuserid ;
        this.modify("supportuserid",supportuserid);
    }

    /**
     * 设置 [AllowLegacyDialogsEmbedding]
     */
    public void setAllowlegacydialogsembedding(Integer allowlegacydialogsembedding){
        this.allowlegacydialogsembedding = allowlegacydialogsembedding ;
        this.modify("allowlegacydialogsembedding",allowlegacydialogsembedding);
    }

    /**
     * 设置 [外部基本 URL]
     */
    public void setExternalbaseurl(String externalbaseurl){
        this.externalbaseurl = externalbaseurl ;
        this.modify("externalbaseurl",externalbaseurl);
    }

    /**
     * 设置 [操作支持功能已启用]
     */
    public void setActionsupportfeatureenabled(Integer actionsupportfeatureenabled){
        this.actionsupportfeatureenabled = actionsupportfeatureenabled ;
        this.modify("actionsupportfeatureenabled",actionsupportfeatureenabled);
    }

    /**
     * 设置 [生成错误警报]
     */
    public void setGeneratealertsforerrors(Integer generatealertsforerrors){
        this.generatealertsforerrors = generatealertsforerrors ;
        this.modify("generatealertsforerrors",generatealertsforerrors);
    }

    /**
     * 设置 [呈现电子邮件的安全框架]
     */
    public void setRendersecureiframeforemail(Integer rendersecureiframeforemail){
        this.rendersecureiframeforemail = rendersecureiframeforemail ;
        this.modify("rendersecureiframeforemail",rendersecureiframeforemail);
    }

    /**
     * 设置 [令牌到期期限]
     */
    public void setTokenexpiry(Integer tokenexpiry){
        this.tokenexpiry = tokenexpiry ;
        this.modify("tokenexpiry",tokenexpiry);
    }

    /**
     * 设置 [定价小数精度]
     */
    public void setPricingdecimalprecision(Integer pricingdecimalprecision){
        this.pricingdecimalprecision = pricingdecimalprecision ;
        this.modify("pricingdecimalprecision",pricingdecimalprecision);
    }

    /**
     * 设置 [ManualSalesForecastingEnabled]
     */
    public void setManualsalesforecastingenabled(Integer manualsalesforecastingenabled){
        this.manualsalesforecastingenabled = manualsalesforecastingenabled ;
        this.modify("manualsalesforecastingenabled",manualsalesforecastingenabled);
    }

    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }

    /**
     * 设置 [启用学习路径创作]
     */
    public void setEnablelpauthoring(Integer enablelpauthoring){
        this.enablelpauthoring = enablelpauthoring ;
        this.modify("enablelpauthoring",enablelpauthoring);
    }

    /**
     * 设置 [用户组]
     */
    public void setUsergroupid(String usergroupid){
        this.usergroupid = usergroupid ;
        this.modify("usergroupid",usergroupid);
    }

    /**
     * 设置 [为此组织启用 Power BI 功能]
     */
    public void setPowerbifeatureenabled(Integer powerbifeatureenabled){
        this.powerbifeatureenabled = powerbifeatureenabled ;
        this.modify("powerbifeatureenabled",powerbifeatureenabled);
    }

    /**
     * 设置 [邮箱永久性问题的下限值。]
     */
    public void setMailboxpermanentissueminrange(Integer mailboxpermanentissueminrange){
        this.mailboxpermanentissueminrange = mailboxpermanentissueminrange ;
        this.modify("mailboxpermanentissueminrange",mailboxpermanentissueminrange);
    }

    /**
     * 设置 [社交透析使用条款]
     */
    public void setSocialinsightstermsaccepted(Integer socialinsightstermsaccepted){
        this.socialinsightstermsaccepted = socialinsightstermsaccepted ;
        this.modify("socialinsightstermsaccepted",socialinsightstermsaccepted);
    }

    /**
     * 设置 [是否启用读取审核]
     */
    public void setReadauditenabled(Integer readauditenabled){
        this.readauditenabled = readauditenabled ;
        this.modify("readauditenabled",readauditenabled);
    }

    /**
     * 设置 [最多记录数筛选选择]
     */
    public void setMaxrecordsforlookupfilters(Integer maxrecordsforlookupfilters){
        this.maxrecordsforlookupfilters = maxrecordsforlookupfilters ;
        this.modify("maxrecordsforlookupfilters",maxrecordsforlookupfilters);
    }

    /**
     * 设置 [基于文件夹的跟踪映射最大数量]
     */
    public void setMaxfolderbasedtrackingmappings(Integer maxfolderbasedtrackingmappings){
        this.maxfolderbasedtrackingmappings = maxfolderbasedtrackingmappings ;
        this.modify("maxfolderbasedtrackingmappings",maxfolderbasedtrackingmappings);
    }

    /**
     * 设置 [基础货币符号]
     */
    public void setBasecurrencysymbol(String basecurrencysymbol){
        this.basecurrencysymbol = basecurrencysymbol ;
        this.modify("basecurrencysymbol",basecurrencysymbol);
    }

    /**
     * 设置 [为此组织启用 MobileOffline]
     */
    public void setMobileofflineenabled(Integer mobileofflineenabled){
        this.mobileofflineenabled = mobileofflineenabled ;
        this.modify("mobileofflineenabled",mobileofflineenabled);
    }

    /**
     * 设置 [默认电子邮件设置]
     */
    public void setDefaultemailsettings(String defaultemailsettings){
        this.defaultemailsettings = defaultemailsettings ;
        this.modify("defaultemailsettings",defaultemailsettings);
    }

    /**
     * 设置 [是否需要审批用户电子邮件]
     */
    public void setRequireapprovalforuseremail(Integer requireapprovalforuseremail){
        this.requireapprovalforuseremail = requireapprovalforuseremail ;
        this.modify("requireapprovalforuseremail",requireapprovalforuseremail);
    }

    /**
     * 设置 [试用组织的 Mobile Offline 服务所需的最小用户许可证数]
     */
    public void setMobileofflineminlicensetrial(Integer mobileofflineminlicensetrial){
        this.mobileofflineminlicensetrial = mobileofflineminlicensetrial ;
        this.modify("mobileofflineminlicensetrial",mobileofflineminlicensetrial);
    }

    /**
     * 设置 [隐私声明 URL]
     */
    public void setPrivacystatementurl(String privacystatementurl){
        this.privacystatementurl = privacystatementurl ;
        this.modify("privacystatementurl",privacystatementurl);
    }

    /**
     * 设置 [哈希最少地址数]
     */
    public void setHashminaddresscount(Integer hashminaddresscount){
        this.hashminaddresscount = hashminaddresscount ;
        this.modify("hashminaddresscount",hashminaddresscount);
    }

    /**
     * 设置 [日历类型]
     */
    public void setCalendartype(Integer calendartype){
        this.calendartype = calendartype ;
        this.modify("calendartype",calendartype);
    }

    /**
     * 设置 [分派时与先前负责人共享]
     */
    public void setSharetopreviousowneronassign(Integer sharetopreviousowneronassign){
        this.sharetopreviousowneronassign = sharetopreviousowneronassign ;
        this.modify("sharetopreviousowneronassign",sharetopreviousowneronassign);
    }

    /**
     * 设置 [当前批量操作号]
     */
    public void setCurrentbulkoperationnumber(Integer currentbulkoperationnumber){
        this.currentbulkoperationnumber = currentbulkoperationnumber ;
        this.modify("currentbulkoperationnumber",currentbulkoperationnumber);
    }

    /**
     * 设置 [Relationship Insights 设置的错误状态。]
     */
    public void setRierrorstatus(Integer rierrorstatus){
        this.rierrorstatus = rierrorstatus ;
        this.modify("rierrorstatus",rierrorstatus);
    }

    /**
     * 设置 [电子邮件连接通道]
     */
    public void setEmailconnectionchannel(String emailconnectionchannel){
        this.emailconnectionchannel = emailconnectionchannel ;
        this.modify("emailconnectionchannel",emailconnectionchannel);
    }

    /**
     * 设置 [允许自动创建响应]
     */
    public void setAllowautoresponsecreation(Integer allowautoresponsecreation){
        this.allowautoresponsecreation = allowautoresponsecreation ;
        this.modify("allowautoresponsecreation",allowautoresponsecreation);
    }

    /**
     * 设置 [是否启用已分派任务同步]
     */
    public void setAssignedtaskssyncenabled(Integer assignedtaskssyncenabled){
        this.assignedtaskssyncenabled = assignedtaskssyncenabled ;
        this.modify("assignedtaskssyncenabled",assignedtaskssyncenabled);
    }

    /**
     * 设置 [唯一字符串长度]
     */
    public void setUniquespecifierlength(Integer uniquespecifierlength){
        this.uniquespecifierlength = uniquespecifierlength ;
        this.modify("uniquespecifierlength",uniquespecifierlength);
    }

    /**
     * 设置 [仅供内部使用。]
     */
    public void setPostmessagewhitelistdomains(String postmessagewhitelistdomains){
        this.postmessagewhitelistdomains = postmessagewhitelistdomains ;
        this.modify("postmessagewhitelistdomains",postmessagewhitelistdomains);
    }

    /**
     * 设置 [已启用自动保存]
     */
    public void setAutosaveenabled(Integer autosaveenabled){
        this.autosaveenabled = autosaveenabled ;
        this.modify("autosaveenabled",autosaveenabled);
    }

    /**
     * 设置 [货币符号]
     */
    public void setCurrencysymbol(String currencysymbol){
        this.currencysymbol = currencysymbol ;
        this.modify("currencysymbol",currencysymbol);
    }

    /**
     * 设置 [是否启用销售订单集成]
     */
    public void setSopintegrationenabled(Integer sopintegrationenabled){
        this.sopintegrationenabled = sopintegrationenabled ;
        this.modify("sopintegrationenabled",sopintegrationenabled);
    }

    /**
     * 设置 [会计期间是否为每月]
     */
    public void setFiscalperiodmonthbased(Integer fiscalperiodmonthbased){
        this.fiscalperiodmonthbased = fiscalperiodmonthbased ;
        this.modify("fiscalperiodmonthbased",fiscalperiodmonthbased);
    }

    /**
     * 设置 [是否启用应用程序模式]
     */
    public void setAppmode(Integer appmode){
        this.appmode = appmode ;
        this.modify("appmode",appmode);
    }

    /**
     * 设置 [全名显示顺序]
     */
    public void setFullnameconventioncode(String fullnameconventioncode){
        this.fullnameconventioncode = fullnameconventioncode ;
        this.modify("fullnameconventioncode",fullnameconventioncode);
    }

    /**
     * 设置 [当前报价单号]
     */
    public void setCurrentquotenumber(Integer currentquotenumber){
        this.currentquotenumber = currentquotenumber ;
        this.modify("currentquotenumber",currentquotenumber);
    }

    /**
     * 设置 [通过电子邮件发送轮询频率]
     */
    public void setEmailsendpollingperiod(Integer emailsendpollingperiod){
        this.emailsendpollingperiod = emailsendpollingperiod ;
        this.modify("emailsendpollingperiod",emailsendpollingperiod);
    }

    /**
     * 设置 [MSTeamsUserSyncEnabled]
     */
    public void setMsteamsusersyncenabled(Integer msteamsusersyncenabled){
        this.msteamsusersyncenabled = msteamsusersyncenabled ;
        this.modify("msteamsusersyncenabled",msteamsusersyncenabled);
    }

    /**
     * 设置 [约会最长持续时间]
     */
    public void setMaxappointmentdurationdays(Integer maxappointmentdurationdays){
        this.maxappointmentdurationdays = maxappointmentdurationdays ;
        this.modify("maxappointmentdurationdays",maxappointmentdurationdays);
    }

    /**
     * 设置 [折扣计算方法]
     */
    public void setDiscountcalculationmethod(String discountcalculationmethod){
        this.discountcalculationmethod = discountcalculationmethod ;
        this.modify("discountcalculationmethod",discountcalculationmethod);
    }

    /**
     * 设置 [生成信息性警报]
     */
    public void setGeneratealertsforinformation(Integer generatealertsforinformation){
        this.generatealertsforinformation = generatealertsforinformation ;
        this.modify("generatealertsforinformation",generatealertsforinformation);
    }

    /**
     * 设置 [是否启用代理访问权限]
     */
    public void setDelegateaccessenabled(Integer delegateaccessenabled){
        this.delegateaccessenabled = delegateaccessenabled ;
        this.modify("delegateaccessenabled",delegateaccessenabled);
    }

    /**
     * 设置 [为此组织启用文本分析]
     */
    public void setTextanalyticsenabled(Integer textanalyticsenabled){
        this.textanalyticsenabled = textanalyticsenabled ;
        this.modify("textanalyticsenabled",textanalyticsenabled);
    }

    /**
     * 设置 [哈希增量主题数]
     */
    public void setHashdeltasubjectcount(Integer hashdeltasubjectcount){
        this.hashdeltasubjectcount = hashdeltasubjectcount ;
        this.modify("hashdeltasubjectcount",hashdeltasubjectcount);
    }

    /**
     * 设置 [预订到期前的天数]
     */
    public void setExpiresubscriptionsindays(Integer expiresubscriptionsindays){
        this.expiresubscriptionsindays = expiresubscriptionsindays ;
        this.modify("expiresubscriptionsindays",expiresubscriptionsindays);
    }

    /**
     * 设置 [知识管理设置]
     */
    public void setKmsettings(String kmsettings){
        this.kmsettings = kmsettings ;
        this.modify("kmsettings",kmsettings);
    }

    /**
     * 设置 [过去的扩展窗口]
     */
    public void setPastexpansionwindow(Integer pastexpansionwindow){
        this.pastexpansionwindow = pastexpansionwindow ;
        this.modify("pastexpansionwindow",pastexpansionwindow);
    }

    /**
     * 设置 [Yammer OAuth 访问令牌已过期]
     */
    public void setYammeroauthaccesstokenexpired(Integer yammeroauthaccesstokenexpired){
        this.yammeroauthaccesstokenexpired = yammeroauthaccesstokenexpired ;
        this.modify("yammeroauthaccesstokenexpired",yammeroauthaccesstokenexpired);
    }

    /**
     * 设置 [用于打开 Delve 的 URL]
     */
    public void setOfficegraphdelveurl(String officegraphdelveurl){
        this.officegraphdelveurl = officegraphdelveurl ;
        this.modify("officegraphdelveurl",officegraphdelveurl);
    }

    /**
     * 设置 [高对比度主题数据]
     */
    public void setHighcontrastthemedata(String highcontrastthemedata){
        this.highcontrastthemedata = highcontrastthemedata ;
        this.modify("highcontrastthemedata",highcontrastthemedata);
    }

    /**
     * 设置 [电子邮件服务器配置文件]
     */
    public void setDefaultemailserverprofileid(String defaultemailserverprofileid){
        this.defaultemailserverprofileid = defaultemailserverprofileid ;
        this.modify("defaultemailserverprofileid",defaultemailserverprofileid);
    }

    /**
     * 设置 [时间格式代码]
     */
    public void setTimeformatcode(String timeformatcode){
        this.timeformatcode = timeformatcode ;
        this.modify("timeformatcode",timeformatcode);
    }

    /**
     * 设置 [小数点]
     */
    public void setDecimalsymbol(String decimalsymbol){
        this.decimalsymbol = decimalsymbol ;
        this.modify("decimalsymbol",decimalsymbol);
    }

    /**
     * 设置 [导出到 Excel 的最多记录数]
     */
    public void setMaxrecordsforexporttoexcel(Integer maxrecordsforexporttoexcel){
        this.maxrecordsforexporttoexcel = maxrecordsforexporttoexcel ;
        this.modify("maxrecordsforexporttoexcel",maxrecordsforexporttoexcel);
    }

    /**
     * 设置 [默认情况下为其启用详细信息日志记录的同步周期的最大数目]
     */
    public void setMaxverboseloggingsynccycles(Integer maxverboseloggingsynccycles){
        this.maxverboseloggingsynccycles = maxverboseloggingsynccycles ;
        this.modify("maxverboseloggingsynccycles",maxverboseloggingsynccycles);
    }

    /**
     * 设置 [自定义名称前缀]
     */
    public void setSchemanameprefix(String schemanameprefix){
        this.schemanameprefix = schemanameprefix ;
        this.modify("schemanameprefix",schemanameprefix);
    }

    /**
     * 设置 [是否需要审批队列电子邮件]
     */
    public void setRequireapprovalforqueueemail(Integer requireapprovalforqueueemail){
        this.requireapprovalforqueueemail = requireapprovalforqueueemail ;
        this.modify("requireapprovalforqueueemail",requireapprovalforqueueemail);
    }

    /**
     * 设置 [ACI 租户 URL。]
     */
    public void setAciwebendpointurl(String aciwebendpointurl){
        this.aciwebendpointurl = aciwebendpointurl ;
        this.modify("aciwebendpointurl",aciwebendpointurl);
    }

    /**
     * 设置 [当前市场活动号]
     */
    public void setCurrentcampaignnumber(Integer currentcampaignnumber){
        this.currentcampaignnumber = currentcampaignnumber ;
        this.modify("currentcampaignnumber",currentcampaignnumber);
    }

    /**
     * 设置 [当前文章编号]
     */
    public void setCurrentkbnumber(Integer currentkbnumber){
        this.currentkbnumber = currentkbnumber ;
        this.modify("currentkbnumber",currentkbnumber);
    }

    /**
     * 设置 [已启用不活动超时]
     */
    public void setInactivitytimeoutenabled(Integer inactivitytimeoutenabled){
        this.inactivitytimeoutenabled = inactivitytimeoutenabled ;
        this.modify("inactivitytimeoutenabled",inactivitytimeoutenabled);
    }

    /**
     * 设置 [Yammer 网络固定链接]
     */
    public void setYammernetworkpermalink(String yammernetworkpermalink){
        this.yammernetworkpermalink = yammernetworkpermalink ;
        this.modify("yammernetworkpermalink",yammernetworkpermalink);
    }

    /**
     * 设置 [会计期间类型]
     */
    public void setFiscalperiodtype(Integer fiscalperiodtype){
        this.fiscalperiodtype = fiscalperiodtype ;
        this.modify("fiscalperiodtype",fiscalperiodtype);
    }

    /**
     * 设置 [当前订单号]
     */
    public void setCurrentordernumber(Integer currentordernumber){
        this.currentordernumber = currentordernumber ;
        this.modify("currentordernumber",currentordernumber);
    }

    /**
     * 设置 [当前案例号]
     */
    public void setCurrentcasenumber(Integer currentcasenumber){
        this.currentcasenumber = currentcasenumber ;
        this.modify("currentcasenumber",currentcasenumber);
    }

    /**
     * 设置 [ExternalPartyEnabled 实体相关键]
     */
    public void setExternalpartycorrelationkeys(String externalpartycorrelationkeys){
        this.externalpartycorrelationkeys = externalpartycorrelationkeys ;
        this.modify("externalpartycorrelationkeys",externalpartycorrelationkeys);
    }

    /**
     * 设置 [CRMForOutlookDownloadURL]
     */
    public void setSignupoutlookdownloadfwlink(String signupoutlookdownloadfwlink){
        this.signupoutlookdownloadfwlink = signupoutlookdownloadfwlink ;
        this.modify("signupoutlookdownloadfwlink",signupoutlookdownloadfwlink);
    }

    /**
     * 设置 [会计期间格式]
     */
    public void setFiscalperiodformat(String fiscalperiodformat){
        this.fiscalperiodformat = fiscalperiodformat ;
        this.modify("fiscalperiodformat",fiscalperiodformat);
    }

    /**
     * 设置 [允许执行市场营销电子邮件]
     */
    public void setAllowmarketingemailexecution(Integer allowmarketingemailexecution){
        this.allowmarketingemailexecution = allowmarketingemailexecution ;
        this.modify("allowmarketingemailexecution",allowmarketingemailexecution);
    }

    /**
     * 设置 [权限报告组名称]
     */
    public void setPrivreportinggroupname(String privreportinggroupname){
        this.privreportinggroupname = privreportinggroupname ;
        this.modify("privreportinggroupname",privreportinggroupname);
    }

    /**
     * 设置 [自动创建文件夹]
     */
    public void setFolderautocreatedonsp(Integer folderautocreatedonsp){
        this.folderautocreatedonsp = folderautocreatedonsp ;
        this.modify("folderautocreatedonsp",folderautocreatedonsp);
    }

    /**
     * 设置 [用户访问审核已启用]
     */
    public void setUseraccessauditenabled(Integer useraccessauditenabled){
        this.useraccessauditenabled = useraccessauditenabled ;
        this.modify("useraccessauditenabled",useraccessauditenabled);
    }

    /**
     * 设置 [SQL 访问组]
     */
    public void setSqlaccessgroupid(String sqlaccessgroupid){
        this.sqlaccessgroupid = sqlaccessgroupid ;
        this.modify("sqlaccessgroupid",sqlaccessgroupid);
    }

    /**
     * 设置 [跟踪令牌基数]
     */
    public void setTrackingtokenidbase(Integer trackingtokenidbase){
        this.trackingtokenidbase = trackingtokenidbase ;
        this.modify("trackingtokenidbase",trackingtokenidbase);
    }

    /**
     * 设置 [合同前缀]
     */
    public void setContractprefix(String contractprefix){
        this.contractprefix = contractprefix ;
        this.modify("contractprefix",contractprefix);
    }

    /**
     * 设置 [BPF 中允许的操作步骤的最大数量]
     */
    public void setMaxactionstepsinbpf(Integer maxactionstepsinbpf){
        this.maxactionstepsinbpf = maxactionstepsinbpf ;
        this.modify("maxactionstepsinbpf",maxactionstepsinbpf);
    }

    /**
     * 设置 [为此组织启用关系分析]
     */
    public void setActivityanalysisenabled(Integer activityanalysisenabled){
        this.activityanalysisenabled = activityanalysisenabled ;
        this.modify("activityanalysisenabled",activityanalysisenabled);
    }

    /**
     * 设置 [类别前缀]
     */
    public void setCategoryprefix(String categoryprefix){
        this.categoryprefix = categoryprefix ;
        this.modify("categoryprefix",categoryprefix);
    }

    /**
     * 设置 [SLA 暂停状态]
     */
    public void setSlapausestates(String slapausestates){
        this.slapausestates = slapausestates ;
        this.modify("slapausestates",slapausestates);
    }

    /**
     * 设置 [组织数据库组织设置]
     */
    public void setOrgdborgsettings(String orgdborgsettings){
        this.orgdborgsettings = orgdborgsettings ;
        this.modify("orgdborgsettings",orgdborgsettings);
    }

    /**
     * 设置 [启用外部搜索数据同步]
     */
    public void setExternalsearchindexenabled(Integer externalsearchindexenabled){
        this.externalsearchindexenabled = externalsearchindexenabled ;
        this.modify("externalsearchindexenabled",externalsearchindexenabled);
    }

    /**
     * 设置 [组织状态]
     */
    public void setOrganizationstate(String organizationstate){
        this.organizationstate = organizationstate ;
        this.modify("organizationstate",organizationstate);
    }

    /**
     * 设置 [阻止附件]
     */
    public void setBlockedattachments(String blockedattachments){
        this.blockedattachments = blockedattachments ;
        this.modify("blockedattachments",blockedattachments);
    }

    /**
     * 设置 [已解析表前缀]
     */
    public void setParsedtableprefix(String parsedtableprefix){
        this.parsedtableprefix = parsedtableprefix ;
        this.modify("parsedtableprefix",parsedtableprefix);
    }

    /**
     * 设置 [语言]
     */
    public void setLanguagecode(Integer languagecode){
        this.languagecode = languagecode ;
        this.modify("languagecode",languagecode);
    }

    /**
     * 设置 [时间分隔符]
     */
    public void setTimeseparator(String timeseparator){
        this.timeseparator = timeseparator ;
        this.modify("timeseparator",timeseparator);
    }

    /**
     * 设置 [最低同步频率]
     */
    public void setMinoutlooksyncinterval(Integer minoutlooksyncinterval){
        this.minoutlooksyncinterval = minoutlooksyncinterval ;
        this.modify("minoutlooksyncinterval",minoutlooksyncinterval);
    }

    /**
     * 设置 [是否启用 SQM]
     */
    public void setSqmenabled(Integer sqmenabled){
        this.sqmenabled = sqmenabled ;
        this.modify("sqmenabled",sqmenabled);
    }

    /**
     * 设置 [选择要与 Microsoft Flow 集成的环境]
     */
    public void setMicrosoftflowenvironment(String microsoftflowenvironment){
        this.microsoftflowenvironment = microsoftflowenvironment ;
        this.modify("microsoftflowenvironment",microsoftflowenvironment);
    }

    /**
     * 设置 [选择 SharePoint 部署类型]
     */
    public void setSharepointdeploymenttype(String sharepointdeploymenttype){
        this.sharepointdeploymenttype = sharepointdeploymenttype ;
        this.modify("sharepointdeploymenttype",sharepointdeploymenttype);
    }

    /**
     * 设置 [在更新服务案例时自动应用默认权利]
     */
    public void setAutoapplydefaultoncaseupdate(Integer autoapplydefaultoncaseupdate){
        this.autoapplydefaultoncaseupdate = autoapplydefaultoncaseupdate ;
        this.modify("autoapplydefaultoncaseupdate",autoapplydefaultoncaseupdate);
    }

    /**
     * 设置 [启用显示状态]
     */
    public void setPresenceenabled(Integer presenceenabled){
        this.presenceenabled = presenceenabled ;
        this.modify("presenceenabled",presenceenabled);
    }

    /**
     * 设置 [为此组织启用 OrgInsights]
     */
    public void setOrginsightsenabled(Integer orginsightsenabled){
        this.orginsightsenabled = orginsightsenabled ;
        this.modify("orginsightsenabled",orginsightsenabled);
    }

    /**
     * 设置 [系统用户]
     */
    public void setSystemuserid(String systemuserid){
        this.systemuserid = systemuserid ;
        this.modify("systemuserid",systemuserid);
    }

    /**
     * 设置 [元数据同步版本]
     */
    public void setMetadatasynctimestamp(BigInteger metadatasynctimestamp){
        this.metadatasynctimestamp = metadatasynctimestamp ;
        this.modify("metadatasynctimestamp",metadatasynctimestamp);
    }

    /**
     * 设置 [报告组名称]
     */
    public void setReportinggroupname(String reportinggroupname){
        this.reportinggroupname = reportinggroupname ;
        this.modify("reportinggroupname",reportinggroupname);
    }

    /**
     * 设置 [自定义全局帮助是否已启用]
     */
    public void setGlobalhelpurlenabled(Integer globalhelpurlenabled){
        this.globalhelpurlenabled = globalhelpurlenabled ;
        this.modify("globalhelpurlenabled",globalhelpurlenabled);
    }

    /**
     * 设置 [客户端功能集]
     */
    public void setClientfeatureset(String clientfeatureset){
        this.clientfeatureset = clientfeatureset ;
        this.modify("clientfeatureset",clientfeatureset);
    }

    /**
     * 设置 [委派的管理员]
     */
    public void setDelegatedadminuserid(String delegatedadminuserid){
        this.delegatedadminuserid = delegatedadminuserid ;
        this.modify("delegatedadminuserid",delegatedadminuserid);
    }

    /**
     * 设置 [插件跟踪日志设置]
     */
    public void setPlugintracelogsetting(String plugintracelogsetting){
        this.plugintracelogsetting = plugintracelogsetting ;
        this.modify("plugintracelogsetting",plugintracelogsetting);
    }

    /**
     * 设置 [汇总目标的到期时间]
     */
    public void setGoalrollupexpirytime(Integer goalrollupexpirytime){
        this.goalrollupexpirytime = goalrollupexpirytime ;
        this.modify("goalrollupexpirytime",goalrollupexpirytime);
    }

    /**
     * 设置 [显示导航教程]
     */
    public void setDisplaynavigationtour(Integer displaynavigationtour){
        this.displaynavigationtour = displaynavigationtour ;
        this.modify("displaynavigationtour",displaynavigationtour);
    }

    /**
     * 设置 [捆绑销售项限制]
     */
    public void setMaxproductsinbundle(Integer maxproductsinbundle){
        this.maxproductsinbundle = maxproductsinbundle ;
        this.modify("maxproductsinbundle",maxproductsinbundle);
    }

    /**
     * 设置 [ISV 集成模式]
     */
    public void setIsvintegrationcode(String isvintegrationcode){
        this.isvintegrationcode = isvintegrationcode ;
        this.modify("isvintegrationcode",isvintegrationcode);
    }

    /**
     * 设置 [Dynamics 365 azure sync 的选择加入操作或选择退出操作的状态。]
     */
    public void setSyncoptinselectionstatus(String syncoptinselectionstatus){
        this.syncoptinselectionstatus = syncoptinselectionstatus ;
        this.modify("syncoptinselectionstatus",syncoptinselectionstatus);
    }

    /**
     * 设置 [启用创建时定价]
     */
    public void setEnablepricingoncreate(Integer enablepricingoncreate){
        this.enablepricingoncreate = enablepricingoncreate ;
        this.modify("enablepricingoncreate",enablepricingoncreate);
    }

    /**
     * 设置 [哈希筛选关键字]
     */
    public void setHashfilterkeywords(String hashfilterkeywords){
        this.hashfilterkeywords = hashfilterkeywords ;
        this.modify("hashfilterkeywords",hashfilterkeywords);
    }

    /**
     * 设置 [AM 指示符]
     */
    public void setAmdesignator(String amdesignator){
        this.amdesignator = amdesignator ;
        this.modify("amdesignator",amdesignator);
    }

    /**
     * 设置 [允许脱机计划同步]
     */
    public void setAllowofflinescheduledsyncs(Integer allowofflinescheduledsyncs){
        this.allowofflinescheduledsyncs = allowofflinescheduledsyncs ;
        this.modify("allowofflinescheduledsyncs",allowofflinescheduledsyncs);
    }

    /**
     * 设置 [默认 Mobile Offline 配置文件]
     */
    public void setDefaultmobileofflineprofileid(String defaultmobileofflineprofileid){
        this.defaultmobileofflineprofileid = defaultmobileofflineprofileid ;
        this.modify("defaultmobileofflineprofileid",defaultmobileofflineprofileid);
    }

    /**
     * 设置 [负数格式]
     */
    public void setNegativeformatcode(String negativeformatcode){
        this.negativeformatcode = negativeformatcode ;
        this.modify("negativeformatcode",negativeformatcode);
    }

    /**
     * 设置 [批量操作前缀]
     */
    public void setBulkoperationprefix(String bulkoperationprefix){
        this.bulkoperationprefix = bulkoperationprefix ;
        this.modify("bulkoperationprefix",bulkoperationprefix);
    }

    /**
     * 设置 [当前合同号]
     */
    public void setCurrentcontractnumber(Integer currentcontractnumber){
        this.currentcontractnumber = currentcontractnumber ;
        this.modify("currentcontractnumber",currentcontractnumber);
    }

    /**
     * 设置 [MSTeamsCollaborationEnabled]
     */
    public void setMsteamscollaborationenabled(Integer msteamscollaborationenabled){
        this.msteamscollaborationenabled = msteamscollaborationenabled ;
        this.modify("msteamscollaborationenabled",msteamscollaborationenabled);
    }

    /**
     * 设置 [启用外部文件存储]
     */
    public void setExternalfilestorageenabled(Integer externalfilestorageenabled){
        this.externalfilestorageenabled = externalfilestorageenabled ;
        this.modify("externalfilestorageenabled",externalfilestorageenabled);
    }

    /**
     * 设置 [令牌密钥]
     */
    public void setTokenkey(String tokenkey){
        this.tokenkey = tokenkey ;
        this.modify("tokenkey",tokenkey);
    }

    /**
     * 设置 [当前发票编号]
     */
    public void setCurrentinvoicenumber(Integer currentinvoicenumber){
        this.currentinvoicenumber = currentinvoicenumber ;
        this.modify("currentinvoicenumber",currentinvoicenumber);
    }

    /**
     * 设置 [SQL 访问组名称]
     */
    public void setSqlaccessgroupname(String sqlaccessgroupname){
        this.sqlaccessgroupname = sqlaccessgroupname ;
        this.modify("sqlaccessgroupname",sqlaccessgroupname);
    }

    /**
     * 设置 [货币小数精度]
     */
    public void setCurrencydecimalprecision(Integer currencydecimalprecision){
        this.currencydecimalprecision = currencydecimalprecision ;
        this.modify("currencydecimalprecision",currencydecimalprecision);
    }

    /**
     * 设置 [会话超时提醒(以分钟为单位)]
     */
    public void setSessiontimeoutreminderinmins(Integer sessiontimeoutreminderinmins){
        this.sessiontimeoutreminderinmins = sessiontimeoutreminderinmins ;
        this.modify("sessiontimeoutreminderinmins",sessiontimeoutreminderinmins);
    }

    /**
     * 设置 [联机状态下每个实体所允许的可用 SLA 的最大数量]
     */
    public void setMaximumentitieswithactivesla(Integer maximumentitieswithactivesla){
        this.maximumentitieswithactivesla = maximumentitieswithactivesla ;
        this.modify("maximumentitieswithactivesla",maximumentitieswithactivesla);
    }

    /**
     * 设置 [为手动替代后自动应用 SLA]
     */
    public void setAutoapplysla(Integer autoapplysla){
        this.autoapplysla = autoapplysla ;
        this.modify("autoapplysla",autoapplysla);
    }

    /**
     * 设置 [节假日日历]
     */
    public void setBusinessclosurecalendarid(String businessclosurecalendarid){
        this.businessclosurecalendarid = businessclosurecalendarid ;
        this.modify("businessclosurecalendarid",businessclosurecalendarid);
    }

    /**
     * 设置 [为此组织启用 One Drive]
     */
    public void setOnedriveenabled(Integer onedriveenabled){
        this.onedriveenabled = onedriveenabled ;
        this.modify("onedriveenabled",onedriveenabled);
    }

    /**
     * 设置 [会计年度格式]
     */
    public void setFiscalyearformat(String fiscalyearformat){
        this.fiscalyearformat = fiscalyearformat ;
        this.modify("fiscalyearformat",fiscalyearformat);
    }

    /**
     * 设置 [Mobile Offline 的同步间隔。]
     */
    public void setMobileofflinesyncinterval(Integer mobileofflinesyncinterval){
        this.mobileofflinesyncinterval = mobileofflinesyncinterval ;
        this.modify("mobileofflinesyncinterval",mobileofflinesyncinterval);
    }

    /**
     * 设置 [参考站点地图 XML]
     */
    public void setReferencesitemapxml(String referencesitemapxml){
        this.referencesitemapxml = referencesitemapxml ;
        this.modify("referencesitemapxml",referencesitemapxml);
    }

    /**
     * 设置 [已启用会话超时]
     */
    public void setSessiontimeoutenabled(Integer sessiontimeoutenabled){
        this.sessiontimeoutenabled = sessiontimeoutenabled ;
        this.modify("sessiontimeoutenabled",sessiontimeoutenabled);
    }

    /**
     * 设置 [当前已解析表的编号]
     */
    public void setCurrentparsedtablenumber(Integer currentparsedtablenumber){
        this.currentparsedtablenumber = currentparsedtablenumber ;
        this.modify("currentparsedtablenumber",currentparsedtablenumber);
    }

    /**
     * 设置 [组织名称]
     */
    public void setOrganizationname(String organizationname){
        this.organizationname = organizationname ;
        this.modify("organizationname",organizationname);
    }

    /**
     * 设置 [数字分组格式]
     */
    public void setNumbergroupformat(String numbergroupformat){
        this.numbergroupformat = numbergroupformat ;
        this.modify("numbergroupformat",numbergroupformat);
    }

    /**
     * 设置 [功能集]
     */
    public void setFeatureset(String featureset){
        this.featureset = featureset ;
        this.modify("featureset",featureset);
    }

    /**
     * 设置 [启动会计日历]
     */
    public void setFiscalcalendarstart(Timestamp fiscalcalendarstart){
        this.fiscalcalendarstart = fiscalcalendarstart ;
        this.modify("fiscalcalendarstart",fiscalcalendarstart);
    }

    /**
     * 格式化日期 [启动会计日历]
     */
    public String formatFiscalcalendarstart(){
        if (this.fiscalcalendarstart == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(fiscalcalendarstart);
    }
    /**
     * 设置 [数字格式]
     */
    public void setNumberformat(String numberformat){
        this.numberformat = numberformat ;
        this.modify("numberformat",numberformat);
    }

    /**
     * 设置 [不活动超时时间(以分钟为单位)]
     */
    public void setInactivitytimeoutinmins(Integer inactivitytimeoutinmins){
        this.inactivitytimeoutinmins = inactivitytimeoutinmins ;
        this.modify("inactivitytimeoutinmins",inactivitytimeoutinmins);
    }

    /**
     * 设置 [允许跟踪有关已发送电子邮件的收件人活动]
     */
    public void setEmailmonitoringallowed(Integer emailmonitoringallowed){
        this.emailmonitoringallowed = emailmonitoringallowed ;
        this.modify("emailmonitoringallowed",emailmonitoringallowed);
    }

    /**
     * 设置 [会计年度期间连接器]
     */
    public void setFiscalyearperiodconnect(String fiscalyearperiodconnect){
        this.fiscalyearperiodconnect = fiscalyearperiodconnect ;
        this.modify("fiscalyearperiodconnect",fiscalyearperiodconnect);
    }

    /**
     * 设置 [是否启用重复检测]
     */
    public void setDuplicatedetectionenabled(Integer duplicatedetectionenabled){
        this.duplicatedetectionenabled = duplicatedetectionenabled ;
        this.modify("duplicatedetectionenabled",duplicatedetectionenabled);
    }

    /**
     * 设置 [已启用社交透析]
     */
    public void setSocialinsightsenabled(Integer socialinsightsenabled){
        this.socialinsightsenabled = socialinsightsenabled ;
        this.modify("socialinsightsenabled",socialinsightsenabled);
    }

    /**
     * 设置 [默认重复结束范围类型]
     */
    public void setDefaultrecurrenceendrangetype(String defaultrecurrenceendrangetype){
        this.defaultrecurrenceendrangetype = defaultrecurrenceendrangetype ;
        this.modify("defaultrecurrenceendrangetype",defaultrecurrenceendrangetype);
    }

    /**
     * 设置 [默认国家/地区代码]
     */
    public void setDefaultcountrycode(String defaultcountrycode){
        this.defaultcountrycode = defaultcountrycode ;
        this.modify("defaultcountrycode",defaultcountrycode);
    }

    /**
     * 设置 [为此组织启用预览操作卡功能]
     */
    public void setPreviewenabledforactioncard(Integer previewenabledforactioncard){
        this.previewenabledforactioncard = previewenabledforactioncard ;
        this.modify("previewenabledforactioncard",previewenabledforactioncard);
    }

    /**
     * 设置 [会计年度格式(年)]
     */
    public void setFiscalyearformatyear(String fiscalyearformatyear){
        this.fiscalyearformatyear = fiscalyearformatyear ;
        this.modify("fiscalyearformatyear",fiscalyearformatyear);
    }

    /**
     * 设置 [启用或禁用国家/地区代码选择]
     */
    public void setDefaultcountrycodecheckenabled(Integer defaultcountrycodecheckenabled){
        this.defaultcountrycodecheckenabled = defaultcountrycodecheckenabled ;
        this.modify("defaultcountrycodecheckenabled",defaultcountrycodecheckenabled);
    }

    /**
     * 设置 [将来的扩展窗口]
     */
    public void setFutureexpansionwindow(Integer futureexpansionwindow){
        this.futureexpansionwindow = futureexpansionwindow ;
        this.modify("futureexpansionwindow",futureexpansionwindow);
    }

    /**
     * 设置 [限制状态更新]
     */
    public void setRestrictstatusupdate(Integer restrictstatusupdate){
        this.restrictstatusupdate = restrictstatusupdate ;
        this.modify("restrictstatusupdate",restrictstatusupdate);
    }

    /**
     * 设置 [当前导入序列号]
     */
    public void setCurrentimportsequencenumber(Integer currentimportsequencenumber){
        this.currentimportsequencenumber = currentimportsequencenumber ;
        this.modify("currentimportsequencenumber",currentimportsequencenumber);
    }

    /**
     * 设置 [示例数据导入]
     */
    public void setSampledataimportid(String sampledataimportid){
        this.sampledataimportid = sampledataimportid ;
        this.modify("sampledataimportid",sampledataimportid);
    }

    /**
     * 设置 [是否启用审核功能]
     */
    public void setAuditenabled(Integer auditenabled){
        this.auditenabled = auditenabled ;
        this.modify("auditenabled",auditenabled);
    }

    /**
     * 设置 [允许自动取消预订]
     */
    public void setAllowautounsubscribe(Integer allowautounsubscribe){
        this.allowautounsubscribe = allowautounsubscribe ;
        this.modify("allowautounsubscribe",allowautounsubscribe);
    }

    /**
     * 设置 [约会和服务活动的计划引擎]
     */
    public void setSchedulingengine(String schedulingengine){
        this.schedulingengine = schedulingengine ;
        this.modify("schedulingengine",schedulingengine);
    }

    /**
     * 设置 [MSTeamsEnabled]
     */
    public void setMsteamsenabled(Integer msteamsenabled){
        this.msteamsenabled = msteamsenabled ;
        this.modify("msteamsenabled",msteamsenabled);
    }

    /**
     * 设置 [启用智能匹配]
     */
    public void setEnablesmartmatching(Integer enablesmartmatching){
        this.enablesmartmatching = enablesmartmatching ;
        this.modify("enablesmartmatching",enablesmartmatching);
    }

    /**
     * 设置 [订单前缀]
     */
    public void setOrderprefix(String orderprefix){
        this.orderprefix = orderprefix ;
        this.modify("orderprefix",orderprefix);
    }

    /**
     * 设置 [UTC 转换时区代码]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }

    /**
     * 设置 [在预览设置中为此组织启用自动捕获功能]
     */
    public void setPreviewforautocaptureenabled(Integer previewforautocaptureenabled){
        this.previewforautocaptureenabled = previewforautocaptureenabled ;
        this.modify("previewforautocaptureenabled",previewforautocaptureenabled);
    }

    /**
     * 设置 [默认应用程序的名称]
     */
    public void setDefaultcrmcustomname(String defaultcrmcustomname){
        this.defaultcrmcustomname = defaultcrmcustomname ;
        this.modify("defaultcrmcustomname",defaultcrmcustomname);
    }

    /**
     * 设置 [日期格式代码]
     */
    public void setDateformatcode(String dateformatcode){
        this.dateformatcode = dateformatcode ;
        this.modify("dateformatcode",dateformatcode);
    }

    /**
     * 设置 [报告脚本错误]
     */
    public void setReportscripterrors(String reportscripterrors){
        this.reportscripterrors = reportscripterrors ;
        this.modify("reportscripterrors",reportscripterrors);
    }

    /**
     * 设置 [为此组织启用 OfficeGraph]
     */
    public void setOfficegraphenabled(Integer officegraphenabled){
        this.officegraphenabled = officegraphenabled ;
        this.modify("officegraphenabled",officegraphenabled);
    }

    /**
     * 设置 [isenabledforallroles 的选项集值]
     */
    public void setEnabledforallroles(Integer enabledforallroles){
        this.enabledforallroles = enabledforallroles ;
        this.modify("enabledforallroles",enabledforallroles);
    }

    /**
     * 设置 [跟踪令牌位数]
     */
    public void setTrackingtokeniddigits(Integer trackingtokeniddigits){
        this.trackingtokeniddigits = trackingtokeniddigits ;
        this.modify("trackingtokeniddigits",trackingtokeniddigits);
    }

    /**
     * 设置 [是否禁用 Social Care]
     */
    public void setDisablesocialcare(Integer disablesocialcare){
        this.disablesocialcare = disablesocialcare ;
        this.modify("disablesocialcare",disablesocialcare);
    }

    /**
     * 设置 [用于强制只读插件的组织设置。]
     */
    public void setEnforcereadonlyplugins(Integer enforcereadonlyplugins){
        this.enforcereadonlyplugins = enforcereadonlyplugins ;
        this.modify("enforcereadonlyplugins",enforcereadonlyplugins);
    }

    /**
     * 设置 [日期分隔符]
     */
    public void setDateseparator(String dateseparator){
        this.dateseparator = dateseparator ;
        this.modify("dateseparator",dateseparator);
    }

    /**
     * 设置 [为隐藏 SLA]
     */
    public void setSuppresssla(Integer suppresssla){
        this.suppresssla = suppresssla ;
        this.modify("suppresssla",suppresssla);
    }

    /**
     * 设置 [用户身份验证审核时间间隔]
     */
    public void setUseraccessauditinginterval(Integer useraccessauditinginterval){
        this.useraccessauditinginterval = useraccessauditinginterval ;
        this.modify("useraccessauditinginterval",useraccessauditinginterval);
    }

    /**
     * 设置 [长日期格式]
     */
    public void setLongdateformatcode(Integer longdateformatcode){
        this.longdateformatcode = longdateformatcode ;
        this.modify("longdateformatcode",longdateformatcode);
    }

    /**
     * 设置 [使用读优化窗体]
     */
    public void setUsereadform(Integer usereadform){
        this.usereadform = usereadform ;
        this.modify("usereadform",usereadform);
    }

    /**
     * 设置 [AllowLegacyClientExperience]
     */
    public void setAllowlegacyclientexperience(Integer allowlegacyclientexperience){
        this.allowlegacyclientexperience = allowlegacyclientexperience ;
        this.modify("allowlegacyclientexperience",allowlegacyclientexperience);
    }

    /**
     * 设置 [为此组织启用 Dynamics 365 azure sync 框架。]
     */
    public void setSyncoptinselection(Integer syncoptinselection){
        this.syncoptinselection = syncoptinselection ;
        this.modify("syncoptinselection",syncoptinselection);
    }

    /**
     * 设置 [MSTeamsSettingChangedByUser]
     */
    public void setMsteamssettingchangedbyuser(Integer msteamssettingchangedbyuser){
        this.msteamssettingchangedbyuser = msteamssettingchangedbyuser ;
        this.modify("msteamssettingchangedbyuser",msteamssettingchangedbyuser);
    }

    /**
     * 设置 [允许计划同步]
     */
    public void setAllowoutlookscheduledsyncs(Integer allowoutlookscheduledsyncs){
        this.allowoutlookscheduledsyncs = allowoutlookscheduledsyncs ;
        this.modify("allowoutlookscheduledsyncs",allowoutlookscheduledsyncs);
    }

    /**
     * 设置 [货币格式代码]
     */
    public void setCurrencyformatcode(String currencyformatcode){
        this.currencyformatcode = currencyformatcode ;
        this.modify("currencyformatcode",currencyformatcode);
    }

    /**
     * 设置 [站点地图 XML]
     */
    public void setSitemapxml(String sitemapxml){
        this.sitemapxml = sitemapxml ;
        this.modify("sitemapxml",sitemapxml);
    }

    /**
     * 设置 [V3 标注哈希]
     */
    public void setV3calloutconfighash(String v3calloutconfighash){
        this.v3calloutconfighash = v3calloutconfighash ;
        this.modify("v3calloutconfighash",v3calloutconfighash);
    }

    /**
     * 设置 [仅供内部使用]
     */
    public void setYammerpostmethod(String yammerpostmethod){
        this.yammerpostmethod = yammerpostmethod ;
        this.modify("yammerpostmethod",yammerpostmethod);
    }

    /**
     * 设置 [市场活动前缀]
     */
    public void setCampaignprefix(String campaignprefix){
        this.campaignprefix = campaignprefix ;
        this.modify("campaignprefix",campaignprefix);
    }

    /**
     * 设置 [使用位置层次结构]
     */
    public void setUsepositionhierarchy(Integer usepositionhierarchy){
        this.usepositionhierarchy = usepositionhierarchy ;
        this.modify("usepositionhierarchy",usepositionhierarchy);
    }

    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }

    /**
     * 设置 [允许用户窗体模式首选项]
     */
    public void setAllowuserformmodepreference(Integer allowuserformmodepreference){
        this.allowuserformmodepreference = allowuserformmodepreference ;
        this.modify("allowuserformmodepreference",allowuserformmodepreference);
    }

    /**
     * 设置 [是否启用基于文件夹的跟踪]
     */
    public void setFolderbasedtrackingenabled(Integer folderbasedtrackingenabled){
        this.folderbasedtrackingenabled = folderbasedtrackingenabled ;
        this.modify("folderbasedtrackingenabled",folderbasedtrackingenabled);
    }

    /**
     * 设置 [是否更新会计设置]
     */
    public void setFiscalsettingsupdated(Integer fiscalsettingsupdated){
        this.fiscalsettingsupdated = fiscalsettingsupdated ;
        this.modify("fiscalsettingsupdated",fiscalsettingsupdated);
    }

    /**
     * 设置 [授予网络服务访问权限]
     */
    public void setGrantaccesstonetworkservice(Integer grantaccesstonetworkservice){
        this.grantaccesstonetworkservice = grantaccesstonetworkservice ;
        this.modify("grantaccesstonetworkservice",grantaccesstonetworkservice);
    }

    /**
     * 设置 [为此组织启用 Relationship Insights]
     */
    public void setRelationshipinsightsenabled(Integer relationshipinsightsenabled){
        this.relationshipinsightsenabled = relationshipinsightsenabled ;
        this.modify("relationshipinsightsenabled",relationshipinsightsenabled);
    }

    /**
     * 设置 [允许导出至 Excel]
     */
    public void setAllowwebexcelexport(Integer allowwebexcelexport){
        this.allowwebexcelexport = allowwebexcelexport ;
        this.modify("allowwebexcelexport",allowwebexcelexport);
    }

    /**
     * 设置 [周起始日代码]
     */
    public void setWeekstartdaycode(String weekstartdaycode){
        this.weekstartdaycode = weekstartdaycode ;
        this.modify("weekstartdaycode",weekstartdaycode);
    }

    /**
     * 设置 [版本号]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }

    /**
     * 设置 [SyncBulkOperationBatchSize]
     */
    public void setSyncbulkoperationbatchsize(Integer syncbulkoperationbatchsize){
        this.syncbulkoperationbatchsize = syncbulkoperationbatchsize ;
        this.modify("syncbulkoperationbatchsize",syncbulkoperationbatchsize);
    }

    /**
     * 设置 [社交透析实例标识符]
     */
    public void setSocialinsightsinstance(String socialinsightsinstance){
        this.socialinsightsinstance = socialinsightsinstance ;
        this.modify("socialinsightsinstance",socialinsightsinstance);
    }

    /**
     * 设置 [启用快速查找的全文搜索]
     */
    public void setFulltextsearchenabled(Integer fulltextsearchenabled){
        this.fulltextsearchenabled = fulltextsearchenabled ;
        this.modify("fulltextsearchenabled",fulltextsearchenabled);
    }

    /**
     * 设置 [为详细日志记录启用的邮箱的最大数量]
     */
    public void setMaxverboseloggingmailbox(Integer maxverboseloggingmailbox){
        this.maxverboseloggingmailbox = maxverboseloggingmailbox ;
        this.modify("maxverboseloggingmailbox",maxverboseloggingmailbox);
    }

    /**
     * 设置 [权限报告组]
     */
    public void setPrivreportinggroupid(String privreportinggroupid){
        this.privreportinggroupid = privreportinggroupid ;
        this.modify("privreportinggroupid",privreportinggroupid);
    }

    /**
     * 设置 [启用文本换行]
     */
    public void setTextwrapenabled(Integer textwrapenabled){
        this.textwrapenabled = textwrapenabled ;
        this.modify("textwrapenabled",textwrapenabled);
    }

    /**
     * 设置 [禁用的原因]
     */
    public void setDisabledreason(String disabledreason){
        this.disabledreason = disabledreason ;
        this.modify("disabledreason",disabledreason);
    }

    /**
     * 设置 [自动标记最大周期数]
     */
    public void setTagmaxaggressivecycles(Integer tagmaxaggressivecycles){
        this.tagmaxaggressivecycles = tagmaxaggressivecycles ;
        this.modify("tagmaxaggressivecycles",tagmaxaggressivecycles);
    }

    /**
     * 设置 [生成警告警报]
     */
    public void setGeneratealertsforwarnings(Integer generatealertsforwarnings){
        this.generatealertsforwarnings = generatealertsforwarnings ;
        this.modify("generatealertsforwarnings",generatealertsforwarnings);
    }

    /**
     * 设置 [知识文章前缀]
     */
    public void setKaprefix(String kaprefix){
        this.kaprefix = kaprefix ;
        this.modify("kaprefix",kaprefix);
    }

    /**
     * 设置 [初始版本]
     */
    public void setInitialversion(String initialversion){
        this.initialversion = initialversion ;
        this.modify("initialversion",initialversion);
    }

    /**
     * 设置 [时区规则版本号]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }

    /**
     * 设置 [已解析表列的前缀]
     */
    public void setParsedtablecolumnprefix(String parsedtablecolumnprefix){
        this.parsedtablecolumnprefix = parsedtablecolumnprefix ;
        this.modify("parsedtablecolumnprefix",parsedtablecolumnprefix);
    }

    /**
     * 设置 [显示周数]
     */
    public void setShowweeknumber(Integer showweeknumber){
        this.showweeknumber = showweeknumber ;
        this.modify("showweeknumber",showweeknumber);
    }

    /**
     * 设置 [为此组织启用产品建议]
     */
    public void setProductrecommendationsenabled(Integer productrecommendationsenabled){
        this.productrecommendationsenabled = productrecommendationsenabled ;
        this.modify("productrecommendationsenabled",productrecommendationsenabled);
    }

    /**
     * 设置 [使用电子邮件相关性]
     */
    public void setEmailcorrelationenabled(Integer emailcorrelationenabled){
        this.emailcorrelationenabled = emailcorrelationenabled ;
        this.modify("emailcorrelationenabled",emailcorrelationenabled);
    }

    /**
     * 设置 [集成用户]
     */
    public void setIntegrationuserid(String integrationuserid){
        this.integrationuserid = integrationuserid ;
        this.modify("integrationuserid",integrationuserid);
    }

    /**
     * 设置 [哈希最大计数]
     */
    public void setHashmaxcount(Integer hashmaxcount){
        this.hashmaxcount = hashmaxcount ;
        this.modify("hashmaxcount",hashmaxcount);
    }

    /**
     * 设置 [报价单前缀]
     */
    public void setQuoteprefix(String quoteprefix){
        this.quoteprefix = quoteprefix ;
        this.modify("quoteprefix",quoteprefix);
    }

    /**
     * 设置 [案例前缀]
     */
    public void setCaseprefix(String caseprefix){
        this.caseprefix = caseprefix ;
        this.modify("caseprefix",caseprefix);
    }

    /**
     * 设置 [PinpointLanguageCode]
     */
    public void setPinpointlanguagecode(Integer pinpointlanguagecode){
        this.pinpointlanguagecode = pinpointlanguagecode ;
        this.modify("pinpointlanguagecode",pinpointlanguagecode);
    }

    /**
     * 设置 [货币负数格式]
     */
    public void setNegativecurrencyformatcode(Integer negativecurrencyformatcode){
        this.negativecurrencyformatcode = negativecurrencyformatcode ;
        this.modify("negativecurrencyformatcode",negativecurrencyformatcode);
    }

    /**
     * 设置 [是否启用入门窗格内容]
     */
    public void setGetstartedpanecontentenabled(Integer getstartedpanecontentenabled){
        this.getstartedpanecontentenabled = getstartedpanecontentenabled ;
        this.modify("getstartedpanecontentenabled",getstartedpanecontentenabled);
    }

    /**
     * 设置 [最大跟踪号]
     */
    public void setMaximumtrackingnumber(Integer maximumtrackingnumber){
        this.maximumtrackingnumber = maximumtrackingnumber ;
        this.modify("maximumtrackingnumber",maximumtrackingnumber);
    }

    /**
     * 设置 [会计年度前缀]
     */
    public void setFiscalyearformatprefix(String fiscalyearformatprefix){
        this.fiscalyearformatprefix = fiscalyearformatprefix ;
        this.modify("fiscalyearformatprefix",fiscalyearformatprefix);
    }

    /**
     * 设置 [实体图像]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }

    /**
     * 设置 [数字分隔符]
     */
    public void setNumberseparator(String numberseparator){
        this.numberseparator = numberseparator ;
        this.modify("numberseparator",numberseparator);
    }

    /**
     * 设置 [发票前缀]
     */
    public void setInvoiceprefix(String invoiceprefix){
        this.invoiceprefix = invoiceprefix ;
        this.modify("invoiceprefix",invoiceprefix);
    }

    /**
     * 设置 [在创建服务案例时自动应用默认权利]
     */
    public void setAutoapplydefaultoncasecreate(Integer autoapplydefaultoncasecreate){
        this.autoapplydefaultoncasecreate = autoapplydefaultoncasecreate ;
        this.modify("autoapplydefaultoncasecreate",autoapplydefaultoncasecreate);
    }

    /**
     * 设置 [实体图像 ID]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }

    /**
     * 设置 [权限用户组]
     */
    public void setPrivilegeusergroupid(String privilegeusergroupid){
        this.privilegeusergroupid = privilegeusergroupid ;
        this.modify("privilegeusergroupid",privilegeusergroupid);
    }

    /**
     * 设置 [忽略 Internal 电子邮件]
     */
    public void setIgnoreinternalemail(Integer ignoreinternalemail){
        this.ignoreinternalemail = ignoreinternalemail ;
        this.modify("ignoreinternalemail",ignoreinternalemail);
    }

    /**
     * 设置 [货币显示格式]
     */
    public void setCurrencydisplayoption(String currencydisplayoption){
        this.currencydisplayoption = currencydisplayoption ;
        this.modify("currencydisplayoption",currencydisplayoption);
    }

    /**
     * 设置 [默认主题数据]
     */
    public void setDefaultthemedata(String defaultthemedata){
        this.defaultthemedata = defaultthemedata ;
        this.modify("defaultthemedata",defaultthemedata);
    }

    /**
     * 设置 [当前知识文章编号]
     */
    public void setCurrentkanumber(Integer currentkanumber){
        this.currentkanumber = currentkanumber ;
        this.modify("currentkanumber",currentkanumber);
    }

    /**
     * 设置 [排序]
     */
    public void setSortid(Integer sortid){
        this.sortid = sortid ;
        this.modify("sortid",sortid);
    }

    /**
     * 设置 [Bing 地图 API 密钥]
     */
    public void setBingmapsapikey(String bingmapsapikey){
        this.bingmapsapikey = bingmapsapikey ;
        this.modify("bingmapsapikey",bingmapsapikey);
    }

    /**
     * 设置 [全局帮助 URL。]
     */
    public void setGlobalhelpurl(String globalhelpurl){
        this.globalhelpurl = globalhelpurl ;
        this.modify("globalhelpurl",globalhelpurl);
    }

    /**
     * 设置 [级联状态更新]
     */
    public void setCascadestatusupdate(Integer cascadestatusupdate){
        this.cascadestatusupdate = cascadestatusupdate ;
        this.modify("cascadestatusupdate",cascadestatusupdate);
    }

    /**
     * 设置 [照片]
     */
    public void setPicture(String picture){
        this.picture = picture ;
        this.modify("picture",picture);
    }

    /**
     * 设置 [自动标记时间间隔]
     */
    public void setTagpollingperiod(Integer tagpollingperiod){
        this.tagpollingperiod = tagpollingperiod ;
        this.modify("tagpollingperiod",tagpollingperiod);
    }

    /**
     * 设置 [更改跟踪已删除的记录到期前的天数]
     */
    public void setExpirechangetrackingindays(Integer expirechangetrackingindays){
        this.expirechangetrackingindays = expirechangetrackingindays ;
        this.modify("expirechangetrackingindays",expirechangetrackingindays);
    }

    /**
     * 设置 [跟踪前缀]
     */
    public void setTrackingprefix(String trackingprefix){
        this.trackingprefix = trackingprefix ;
        this.modify("trackingprefix",trackingprefix);
    }

    /**
     * 设置 [显示会计年度]
     */
    public void setFiscalyeardisplaycode(Integer fiscalyeardisplaycode){
        this.fiscalyeardisplaycode = fiscalyeardisplaycode ;
        this.modify("fiscalyeardisplaycode",fiscalyeardisplaycode);
    }

    /**
     * 设置 [上载文件最大大小]
     */
    public void setMaxuploadfilesize(Integer maxuploadfilesize){
        this.maxuploadfilesize = maxuploadfilesize ;
        this.modify("maxuploadfilesize",maxuploadfilesize);
    }

    /**
     * 设置 [为此组织启用操作卡]
     */
    public void setActioncardenabled(Integer actioncardenabled){
        this.actioncardenabled = actioncardenabled ;
        this.modify("actioncardenabled",actioncardenabled);
    }

    /**
     * 设置 [会话超时时间(以分钟为单位)]
     */
    public void setSessiontimeoutinmins(Integer sessiontimeoutinmins){
        this.sessiontimeoutinmins = sessiontimeoutinmins ;
        this.modify("sessiontimeoutinmins",sessiontimeoutinmins);
    }

    /**
     * 设置 [SyncBulkOperationMaxLimit]
     */
    public void setSyncbulkoperationmaxlimit(Integer syncbulkoperationmaxlimit){
        this.syncbulkoperationmaxlimit = syncbulkoperationmaxlimit ;
        this.modify("syncbulkoperationmaxlimit",syncbulkoperationmaxlimit);
    }

    /**
     * 设置 [邮箱强制解锁是否启用]
     */
    public void setMailboxforcedunlockingenabled(Integer mailboxforcedunlockingenabled){
        this.mailboxforcedunlockingenabled = mailboxforcedunlockingenabled ;
        this.modify("mailboxforcedunlockingenabled",mailboxforcedunlockingenabled);
    }

    /**
     * 设置 [基础货币精度]
     */
    public void setBasecurrencyprecision(Integer basecurrencyprecision){
        this.basecurrencyprecision = basecurrencyprecision ;
        this.modify("basecurrencyprecision",basecurrencyprecision);
    }

    /**
     * 设置 [地址同步最低频率]
     */
    public void setMinaddressbooksyncinterval(Integer minaddressbooksyncinterval){
        this.minaddressbooksyncinterval = minaddressbooksyncinterval ;
        this.modify("minaddressbooksyncinterval",minaddressbooksyncinterval);
    }

    /**
     * 设置 [启用 Bing 地图集成]
     */
    public void setEnablebingmapsintegration(Integer enablebingmapsintegration){
        this.enablebingmapsintegration = enablebingmapsintegration ;
        this.modify("enablebingmapsintegration",enablebingmapsintegration);
    }

    /**
     * 设置 [是否启用邮箱保持连接]
     */
    public void setMailboxinactivebackoffenabled(Integer mailboxinactivebackoffenabled){
        this.mailboxinactivebackoffenabled = mailboxinactivebackoffenabled ;
        this.modify("mailboxinactivebackoffenabled",mailboxinactivebackoffenabled);
    }

    /**
     * 设置 [快速查找记录限制已启用]
     */
    public void setQuickfindrecordlimitenabled(Integer quickfindrecordlimitenabled){
        this.quickfindrecordlimitenabled = quickfindrecordlimitenabled ;
        this.modify("quickfindrecordlimitenabled",quickfindrecordlimitenabled);
    }

    /**
     * 设置 [会计期间的格式]
     */
    public void setFiscalperiodformatperiod(String fiscalperiodformatperiod){
        this.fiscalperiodformatperiod = fiscalperiodformatperiod ;
        this.modify("fiscalperiodformatperiod",fiscalperiodformatperiod);
    }

    /**
     * 设置 [文章前缀]
     */
    public void setKbprefix(String kbprefix){
        this.kbprefix = kbprefix ;
        this.modify("kbprefix",kbprefix);
    }

    /**
     * 设置 [PM 指示符]
     */
    public void setPmdesignator(String pmdesignator){
        this.pmdesignator = pmdesignator ;
        this.modify("pmdesignator",pmdesignator);
    }

    /**
     * 设置 [确认模板]
     */
    public void setAcknowledgementtemplateid(String acknowledgementtemplateid){
        this.acknowledgementtemplateid = acknowledgementtemplateid ;
        this.modify("acknowledgementtemplateid",acknowledgementtemplateid);
    }

    /**
     * 设置 [货币]
     */
    public void setBasecurrencyid(String basecurrencyid){
        this.basecurrencyid = basecurrencyid ;
        this.modify("basecurrencyid",basecurrencyid);
    }


}


