package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[团队模板]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "TEAMTEMPLATE",resultMap = "TeamTemplateResultMap")
public class TeamTemplate extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 名称
     */
    @TableField(value = "teamtemplatename")
    @JSONField(name = "teamtemplatename")
    @JsonProperty("teamtemplatename")
    private String teamtemplatename;
    /**
     * 访问权限
     */
    @TableField(value = "defaultaccessrightsmask")
    @JSONField(name = "defaultaccessrightsmask")
    @JsonProperty("defaultaccessrightsmask")
    private Integer defaultaccessrightsmask;
    /**
     * 实体
     */
    @TableField(value = "objecttypecode")
    @JSONField(name = "objecttypecode")
    @JsonProperty("objecttypecode")
    private Integer objecttypecode;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 说明
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * 团队模板的主键
     */
    @DEField(isKeyField=true)
    @TableId(value= "teamtemplateid",type=IdType.UUID)
    @JSONField(name = "teamtemplateid")
    @JsonProperty("teamtemplateid")
    private String teamtemplateid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 由系统定义
     */
    @DEField(defaultValue = "0")
    @TableField(value = "system")
    @JSONField(name = "system")
    @JsonProperty("system")
    private Integer system;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;



    /**
     * 设置 [名称]
     */
    public void setTeamtemplatename(String teamtemplatename){
        this.teamtemplatename = teamtemplatename ;
        this.modify("teamtemplatename",teamtemplatename);
    }

    /**
     * 设置 [访问权限]
     */
    public void setDefaultaccessrightsmask(Integer defaultaccessrightsmask){
        this.defaultaccessrightsmask = defaultaccessrightsmask ;
        this.modify("defaultaccessrightsmask",defaultaccessrightsmask);
    }

    /**
     * 设置 [实体]
     */
    public void setObjecttypecode(Integer objecttypecode){
        this.objecttypecode = objecttypecode ;
        this.modify("objecttypecode",objecttypecode);
    }

    /**
     * 设置 [说明]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }

    /**
     * 设置 [由系统定义]
     */
    public void setSystem(Integer system){
        this.system = system ;
        this.modify("system",system);
    }


}


