package cn.ibizlab.businesscentral.core.runtime.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[批量操作日志]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "BULKOPERATIONLOG",resultMap = "BulkOperationLogResultMap")
public class BulkOperationLog extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 负责人
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * 错误号
     */
    @TableField(value = "errornumber")
    @JSONField(name = "errornumber")
    @JsonProperty("errornumber")
    private Integer errornumber;
    /**
     * 关于
     */
    @TableField(value = "regardingobjectidtypecode")
    @JSONField(name = "regardingobjectidtypecode")
    @JsonProperty("regardingobjectidtypecode")
    private String regardingobjectidtypecode;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 负责人
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * Time Zone Rule Version Number
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * Record Created On
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * CreatedObjectIdYomiName
     */
    @TableField(value = "createdobjectidyominame")
    @JSONField(name = "createdobjectidyominame")
    @JsonProperty("createdobjectidyominame")
    private String createdobjectidyominame;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * UTC Conversion Time Zone Code
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * ErrorDescriptionFormatted
     */
    @TableField(value = "errordescriptionformatted")
    @JSONField(name = "errordescriptionformatted")
    @JsonProperty("errordescriptionformatted")
    private String errordescriptionformatted;
    /**
     * ErrorNumberFormatted
     */
    @TableField(value = "errornumberformatted")
    @JSONField(name = "errornumberformatted")
    @JsonProperty("errornumberformatted")
    private String errornumberformatted;
    /**
     * CreatedObjectIdTypeCode
     */
    @TableField(value = "createdobjectidtypecode")
    @JSONField(name = "createdobjectidtypecode")
    @JsonProperty("createdobjectidtypecode")
    private String createdobjectidtypecode;
    /**
     * 被排除的客户
     */
    @TableField(value = "regardingobjectid")
    @JSONField(name = "regardingobjectid")
    @JsonProperty("regardingobjectid")
    private String regardingobjectid;
    /**
     * 在以下行失败
     */
    @TableField(value = "additionalinfo")
    @JSONField(name = "additionalinfo")
    @JsonProperty("additionalinfo")
    private String additionalinfo;
    /**
     * BulkOperationIdType
     */
    @TableField(value = "bulkoperationidtype")
    @JSONField(name = "bulkoperationidtype")
    @JsonProperty("bulkoperationidtype")
    private String bulkoperationidtype;
    /**
     * 关于
     */
    @TableField(value = "regardingobjectidyominame")
    @JSONField(name = "regardingobjectidyominame")
    @JsonProperty("regardingobjectidyominame")
    private String regardingobjectidyominame;
    /**
     * Import Sequence Number
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * 批量操作日志编号
     */
    @DEField(isKeyField=true)
    @TableId(value= "bulkoperationlogid",type=IdType.UUID)
    @JSONField(name = "bulkoperationlogid")
    @JsonProperty("bulkoperationlogid")
    private String bulkoperationlogid;
    /**
     * Version Number
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * BulkOperationIdYomiName
     */
    @TableField(value = "bulkoperationidyominame")
    @JSONField(name = "bulkoperationidyominame")
    @JsonProperty("bulkoperationidyominame")
    private String bulkoperationidyominame;
    /**
     * 创建的对象
     */
    @TableField(value = "createdobjectid")
    @JSONField(name = "createdobjectid")
    @JsonProperty("createdobjectid")
    private String createdobjectid;
    /**
     * 批除操作日志名称
     */
    @TableField(value = "bulkoperationlogname")
    @JSONField(name = "bulkoperationlogname")
    @JsonProperty("bulkoperationlogname")
    private String bulkoperationlogname;
    /**
     * 负责人类型
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * 批量操作号
     */
    @TableField(value = "bulkoperationid")
    @JSONField(name = "bulkoperationid")
    @JsonProperty("bulkoperationid")
    private String bulkoperationid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.ActivityPointer bulkoperation;



    /**
     * 设置 [负责人]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }

    /**
     * 设置 [错误号]
     */
    public void setErrornumber(Integer errornumber){
        this.errornumber = errornumber ;
        this.modify("errornumber",errornumber);
    }

    /**
     * 设置 [关于]
     */
    public void setRegardingobjectidtypecode(String regardingobjectidtypecode){
        this.regardingobjectidtypecode = regardingobjectidtypecode ;
        this.modify("regardingobjectidtypecode",regardingobjectidtypecode);
    }

    /**
     * 设置 [负责人]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }

    /**
     * 设置 [Time Zone Rule Version Number]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }

    /**
     * 设置 [Record Created On]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }

    /**
     * 格式化日期 [Record Created On]
     */
    public String formatOverriddencreatedon(){
        if (this.overriddencreatedon == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(overriddencreatedon);
    }
    /**
     * 设置 [CreatedObjectIdYomiName]
     */
    public void setCreatedobjectidyominame(String createdobjectidyominame){
        this.createdobjectidyominame = createdobjectidyominame ;
        this.modify("createdobjectidyominame",createdobjectidyominame);
    }

    /**
     * 设置 [UTC Conversion Time Zone Code]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }

    /**
     * 设置 [ErrorDescriptionFormatted]
     */
    public void setErrordescriptionformatted(String errordescriptionformatted){
        this.errordescriptionformatted = errordescriptionformatted ;
        this.modify("errordescriptionformatted",errordescriptionformatted);
    }

    /**
     * 设置 [ErrorNumberFormatted]
     */
    public void setErrornumberformatted(String errornumberformatted){
        this.errornumberformatted = errornumberformatted ;
        this.modify("errornumberformatted",errornumberformatted);
    }

    /**
     * 设置 [CreatedObjectIdTypeCode]
     */
    public void setCreatedobjectidtypecode(String createdobjectidtypecode){
        this.createdobjectidtypecode = createdobjectidtypecode ;
        this.modify("createdobjectidtypecode",createdobjectidtypecode);
    }

    /**
     * 设置 [被排除的客户]
     */
    public void setRegardingobjectid(String regardingobjectid){
        this.regardingobjectid = regardingobjectid ;
        this.modify("regardingobjectid",regardingobjectid);
    }

    /**
     * 设置 [在以下行失败]
     */
    public void setAdditionalinfo(String additionalinfo){
        this.additionalinfo = additionalinfo ;
        this.modify("additionalinfo",additionalinfo);
    }

    /**
     * 设置 [BulkOperationIdType]
     */
    public void setBulkoperationidtype(String bulkoperationidtype){
        this.bulkoperationidtype = bulkoperationidtype ;
        this.modify("bulkoperationidtype",bulkoperationidtype);
    }

    /**
     * 设置 [关于]
     */
    public void setRegardingobjectidyominame(String regardingobjectidyominame){
        this.regardingobjectidyominame = regardingobjectidyominame ;
        this.modify("regardingobjectidyominame",regardingobjectidyominame);
    }

    /**
     * 设置 [Import Sequence Number]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }

    /**
     * 设置 [Version Number]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }

    /**
     * 设置 [BulkOperationIdYomiName]
     */
    public void setBulkoperationidyominame(String bulkoperationidyominame){
        this.bulkoperationidyominame = bulkoperationidyominame ;
        this.modify("bulkoperationidyominame",bulkoperationidyominame);
    }

    /**
     * 设置 [创建的对象]
     */
    public void setCreatedobjectid(String createdobjectid){
        this.createdobjectid = createdobjectid ;
        this.modify("createdobjectid",createdobjectid);
    }

    /**
     * 设置 [批除操作日志名称]
     */
    public void setBulkoperationlogname(String bulkoperationlogname){
        this.bulkoperationlogname = bulkoperationlogname ;
        this.modify("bulkoperationlogname",bulkoperationlogname);
    }

    /**
     * 设置 [负责人类型]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }

    /**
     * 设置 [批量操作号]
     */
    public void setBulkoperationid(String bulkoperationid){
        this.bulkoperationid = bulkoperationid ;
        this.modify("bulkoperationid",bulkoperationid);
    }


}


